// configuration :)

#include "configuration.h"
#include <windows.h>
//#include <string>
#include "string2.h"
//#include <istream>
#include <sstream>
//#include <strstream>
using namespace std;
#include "error.h"
#include "types.h"
#include "main.h"
#include "trayicon.h"
#include "hotkeys.h"
#include "volume.h"
#include "c_string.h"
#include "cvars.h"


Config_ParsingSubr_Plain_t* config_ParsingSubr_Plain = 0;
Config_ParsingSubr_t* config_ParsingSubr = 0;
const char* config_filename = 0;
uint config_string_num = 0;
#define CONFIG_FILE_SIZE_MAX (1024 * 1024)


// hexa-decimal ansi to long
//bool HDAToL (string* str, long* l_out)
bool HDAToL (const char* str, long* l_out)
{
	int i_result;
	Assert(l_out);
//	i_result = sscanf (str->c_str (), "%lx", l_out);
	i_result = sscanf (str, "%lx", l_out);
	return i_result == 1;
}

bool HDAToUL (const char* str, ulong* l_out)
{
	int i_result;
	Assert(l_out);
	i_result = sscanf (str, "%lx", l_out);
	return i_result == 1;
}

#if 0
bool Config_ParseColourCmdAndArg (const char* str_cmd, const char* str_arg, const char* str_var_name, ulong* value_colour)
{
	bool result;
	int i_result;
	uint args_num;

	args_num = vec_str_line.size();
	Assert(str_cmd);
	Assert(value_colour);
// in case if #define will appear crappy
	Assert((void*)str_cmd != (void*)value_colour);
	i_result = strcmp (str_cmd, str_var_name);
	if (i_result)
		return 0;
	result = HDAToUL (str_arg, value_colour);
	if (! result)
		Error ("Config :  line colour value converting fail (\"%s\"); must be 8 hexadecimal characters", str_arg);
	return 1;
}
#else
bool Config_ParseColourCmdAndArg (vec_str_t& vec_str_line, const char* str_var_name, ulong* value_colour)
{
	bool result;
	int i_result;
	uint args_num;
	const char* str_cmd;
	const char* str_arg;

	args_num = vec_str_line.size();
	Assert(args_num);
// exclude cmd
	args_num--;
//	Assert(str_cmd);
	str_cmd = vec_str_line[0].c_str();
	Assert(value_colour);
// in case if #define will appear crappy
	Assert((void*)str_cmd != (void*)value_colour);
	i_result = strcmp (str_cmd, str_var_name);
	if (i_result)
		return 0;
// *duplicate
	if (args_num != 1)
		Error ("Config :  line %u, command requires 1 argument, got %u", config_string_num, args_num);
	str_arg = vec_str_line[1].c_str();
	result = HDAToUL (str_arg, value_colour);
	if (! result)
		Error ("Config :  line colour value converting fail (\"%s\"); must be 8 hexadecimal characters", str_arg);
	return 1;
}
#endif

bool Config_ParseLineFuncCmdAndArg (vec_str_t& vec_str_line, const char* str_var_name, uint line_ix)
{
	bool r;
	int i_r;
	uint args_num;
	const char* str_cmd;

	args_num = vec_str_line.size();
	Assert(args_num);
// exclude cmd
	args_num--;
	str_cmd = vec_str_line[0].c_str();
	i_r = strcmp (str_cmd, str_var_name);
	if (i_r)
		return 0;
// *duplicate
	if (args_num != 1)
		Error ("Config :  line %u, command requires 1 argument, got %u", config_string_num, args_num);
	vec_str_line[1];
//	r = TrayIcon_LineSetFunction (line_ix, vec_str_line[1]);
	r = TrayIcon_LineSetFunction (line_ix, vec_str_line[1].c_str());
	if (! r)
		return 0;
	return 1;
}

#if 0
#define CONFIG_PARSE_COLOUR_CMD(_var_name_) \
{ \
	r = Config_ParseColourCmdAndArg (cmd.c_str(), arg.c_str(), #_var_name_, &_var_name_); \
	if (r) \
		return 1; \
}
#endif
#if 0
#define CONFIG_PARSE_COLOUR_CMD(_var_name_) \
{ \
	CONFIG_CHECK_ARGS_NUM(1); \
	r = Config_ParseColourCmdAndArg (cmd.c_str(), arg1.c_str(), #_var_name_, &_var_name_); \
	if (r) \
		return 1; \
}
#endif
//	r = Config_ParseColourCmdAndArg (vec_str_line, #_var_name_, &_var_name_);
#define CONFIG_PARSE_COLOUR_CMD(_var_name_) \
{ \
	r = Config_ParseColourCmdAndArg (vec_str_line, #_var_name_, &_var_name_); \
	if (r) \
		return 1; \
}

#define CONFIG_PARSE_LINE_FUNC(_line_ix_) \
{ \
	r = Config_ParseLineFuncCmdAndArg (vec_str_line, "graph_line_function_"#_line_ix_, _line_ix_); \
	if (r) \
		return 1; \
}

//bool Config_ParseString_MainConfig_CmdAndArg (string cmd, string arg)
bool Config_ParseString_MainConfig_CmdAndArg (vec_str_t& vec_str_line)
{
	bool r;
	int i_r;
	string& cmd = vec_str_line[0];
	string& arg1 = vec_str_line[1];
	stringstream strm;
	string val0;
	string val1;
	string val2;
// cmd as arg is not included
	uint args_num;
	uint required_args_num;
	vec_str_t vec_str_args;

	Assert(vec_str_line.size());

	r = Cvars_ParseCommandLine (vec_str_line);
	if (r)
		return 1;

// currently here are no a just command
//	if (vec_str_line.size() < 2)
//		Error ("Config :  line %u, command without an argument", config_string_num);
	args_num = vec_str_line.size() - 1;
//	strm << arg;
	strm << arg1;
// ==== would be good to make normal config parsers, instead of this dump of code ... ====
	i_r = cmd.compare("refreshlock");
	if (! i_r)
	{
		CONFIG_CHECK_ARGS_NUM(1);
		strm >> g_config_settings.refreshlock;
		if (strm.fail() || ! strm.eof())
			goto error_arg_numeric;
		return 1;
	}
// this is intended to be done before a resolution change
	i_r = cmd.compare("refreshlock_delay_ms");
	if (! i_r)
	{
		CONFIG_CHECK_ARGS_NUM(1);
		strm >> g_config_settings.refreshlock_delay;
		if (strm.fail() || ! strm.eof())
			goto error_arg_numeric;
		return 1;
	}

	i_r = cmd.compare("graph_lines_num");
	if (! i_r)
	{
		CONFIG_CHECK_ARGS_NUM(1);
		strm >> graph_lines_num;
		if (strm.fail() || ! strm.eof())
			goto error_arg_numeric;
		if (graph_lines_num != 3 && graph_lines_num != 5)
			Error ("Config :  only 3 or 5 graph lines are supported");
		return 1;
	}
	CONFIG_PARSE_COLOUR_CMD(graph_background_color);
	CONFIG_PARSE_COLOUR_CMD(graph_line_color_0);
	CONFIG_PARSE_COLOUR_CMD(graph_line_color_1);
	CONFIG_PARSE_COLOUR_CMD(graph_line_color_2);
	CONFIG_PARSE_COLOUR_CMD(graph_line_color_3);
	CONFIG_PARSE_COLOUR_CMD(graph_line_color_4);
	CONFIG_PARSE_LINE_FUNC(0);
	CONFIG_PARSE_LINE_FUNC(1);
	CONFIG_PARSE_LINE_FUNC(2);
	CONFIG_PARSE_LINE_FUNC(3);
	CONFIG_PARSE_LINE_FUNC(4);
#if 0
	i_r = cmd.compare("graph_background_color");
	if (! i_r)
	{
		r = HDAToUL (arg.c_str(), &graph_background_color);
		if (! r)
			Error ("Config :  line colour value converting fail (\"%s\"); must be 8 hexadecimal characters", arg.c_str());
		return 1;
	}
#endif
	i_r = cmd.compare("hotkey_modifier");
	if (! i_r)
	{
		vec_str_args.assign(vec_str_line.begin() + 1, vec_str_line.end());
		Hotkey_SetModifier (vec_str_args);
		return 1;
	}
	i_r = cmd.compare("hotkey");
	if (! i_r)
	{
		CONFIG_CHECK_ARGS_NUM_MIN(1);
		vec_str_args.assign(vec_str_line.begin() + 1, vec_str_line.end());
#if 0
//**
		strm >> val0;
		if (val0.empty())
			Error ("Config :  hotkey definition have no argument\nFor the first will be necessary a virtual key code.");
		strm >> val1;
		if (val1.empty())
			Error ("Config :  hotkey definition have no action");
// get the remainder
		ws(strm);
		getline(strm, val2);
//		if (val2.empty())
//			Error ("Config :  hotkey command have no argument for the action");
//		r = Config_ParseHotkey (val0, val1, val2);
		r = Hotkey_Parse (val0.c_str(), val1.c_str(), val2.c_str());
#endif
		r = Hotkey_Parse (vec_str_args);
		if (! r)
			return 0;
		return 1;
	}
// *uint
	i_r = cmd.compare("volume_device");
	if (! i_r)
	{
		CONFIG_CHECK_ARGS_NUM(1);
		strm >> volume_device;
		if (strm.fail() || ! strm.eof())
			goto error_arg_numeric;
		return 1;
	}
	i_r = cmd.compare("volume_step");
	if (! i_r)
	{
		CONFIG_CHECK_ARGS_NUM(1);
		strm >> volume_step;
		if (strm.fail() || ! strm.eof())
			goto error_arg_numeric;
		return 1;
	}

	Error ("Config command \"%s\" is unknown", cmd.c_str());
	return 0;

error_arg_numeric:
//	Error ("Config command \"%s\" :  failed to read arg \"%s\" as numeric", cmd.c_str(), arg.c_str());
	Error ("Config command \"%s\" :  failed to read arg \"%s\" as numeric", cmd.c_str(), arg1.c_str());
	return 0;

wrong_args_num:
	Error ("Config :  line %u, command requires %u arguments, got %u", config_string_num, required_args_num, args_num);
	return 0;
}

#if 0
// old entrance
bool Config_ParseString_MainConfig_ (const char* cfg_str)
{
	bool r;
	stringstream strm;
	string cmd;
	string arg;

	strm << cfg_str;
	strm >> cmd;
// now copy the remainder with any kind of spacers
// lets use <string>'s getline()
	ws(strm);
	getline(strm, arg);
	r = Config_ParseString_MainConfig_CmdAndArg (cmd, arg);

	return r;
}

// new entrance
#endif
// return value is currently not in use, because before any 'return 0' goes 'Error ()'
bool Config_ParseString_MainConfig (vec_str_t& vec_str_line)
{
	return Config_ParseString_MainConfig_CmdAndArg (vec_str_line);
//	return 0;
//	return 1;
}

// look on this function as parsing a preprocessed text
// command should not contain a space; but this is possible to support, and XML configs seems allowing it, so lets parse whole line "linearily"
bool Config_ParseLinePreprocessed (string str)
{
	bool result;
	vec_str_t vec_str_line;
	string::iterator it;
	string::iterator it_end;
	string s;
	char c;
	bool have_string;
	bool in_raw_string;

	it = str.begin();
	it_end = str.end();
	in_raw_string = 0;
loop_arguments:
	s.erase();
	have_string = 0;
loop_characters:
	if (it == it_end)
		goto arg_end;
	c = *it;
	it++;
	if (in_raw_string)
	{
		if (c == '`')
			in_raw_string = 0;
		else
			s += c;
		goto loop_characters;
	}
	switch (c)
	{
#if 0
	case 0:
//		goto line_parsed;
//		goto arg_end;
		break;
#endif
// arguments separator
	case '\t':
	case 0x20:
		goto arg_end;
//		break;
// C string
	case '\"':
// hacky a bit
		it--;
//		result = CString_Read (s, it);
		result = CString_Read (s, it, it_end);
//		if (result)
//			goto loop_characters;
		if (! result)
			Error ("CString_Read () has returned error \"%s\"", cstring_error_text);
		have_string = 1;
		break;
// left apostrophe - raw string
	case '`':
		in_raw_string = 1;
		have_string = 1;
//		goto loop_characters;
		break;
	default:
// since no unicode support atm - allow those characters
// and hmmm, should those characters be disallowed (?) - I don't think so; since config file atm isn't unicode, and doubtly will be
//		if (c < 0x20 || c >= 0x80)
		if (c < 0x20)
			Error ("config \"%s\", character %02x", config_filename, c);
		s += c;
//		goto loop_characters;
		break;
	}
	have_string = 1;
	goto loop_characters;

// space separator or the given string end
arg_end:
	if (in_raw_string)
		Error ("config \"%s\", '`' raw string is unfinished", config_filename);
// no !  length is allowed to be zero
//	if (s.length())
	if (have_string)
		vec_str_line.push_back(s);
//	if (c)
	if (it != it_end)
		goto loop_arguments;
//line_parsed:

	if (! vec_str_line.size())
		return 1;

// temp
// hmmm, maybe not temp; possibly I will need both kind of parsers
#if 1
	if (! config_ParsingSubr)
		result = 1;
	else
#endif
	result = config_ParsingSubr (vec_str_line);
	if (! result)
		return 0;

	return 1;
}

// remove spaces at begin and at end
// skip the line if comment
// look on this function as on preprocessor
bool Config_ParseLine (string str)
{
	bool result;

	trimbegin(str);
	if (str.empty())
		return 1;
	if (str.length() >= 2)
		if (str[0] == '/')
			if (str[1] == '/')
				return 1;
	trimend(str);
	Assert(! config_ParsingSubr_Plain ^ ! config_ParsingSubr);
// "modes.cfg" seems still will need it
#if 1
// old
#if 1
	if (! config_ParsingSubr_Plain)
		result = 1;
	else
#endif
	result = config_ParsingSubr_Plain (str.c_str());
	if (! result)
		return 0;
// new
//	result = config_ParsingSubr (str.c_str());
#endif
	result = Config_ParseLinePreprocessed (str);
	if (! result)
		return 0;
	return 1;
}

void Config_ParseBuffer (const char* buffer, uint buffer_size)
{
	bool result;
	string str;
	stringstream strm;

	str.assign(buffer, buffer_size);
	strm << str;
	config_string_num = 1;
loop:
	getline(strm, str);
	if (strm.fail())
	{
		if (! strm.eof())
			Error ("Config_ParseBuffer () :  extracting string from config has failed");
		return;
	}
	result = Config_ParseLine (str);
	if (! result)
		return;
	config_string_num++;
	goto loop;
}

void Config_Read (const char* filename)
{
	HANDLE h_file;
	DWORD D_result;
	BOOL B_result;
	char* buffer;
	uint file_size;
	DWORD bytes_read_num;

//	Hotkey_Modifier_Clear ();
	config_filename = filename;

	D_result = GetFileAttributes (filename);
	if (D_result == -1)
// just return
//		return;
// no, this also is abnormal
	{
		D_result = GetLastError ();
		if (D_result == ERROR_FILE_NOT_FOUND)
		{
// "C:\Documents and Settings\Administrator", if starting it from registry together with Windows startup
#if 1
			DWORD D;
			char buf[1024];
// cwd test
			D = GetCurrentDirectory (sizeof(buf), buf);
			if (D)
				Error ("config file \"%s\" is not found\ncurrent working directory is\n\"%s\"", filename, buf);
			else
#endif
			Error ("config file \"%s\" is not found", filename);
		}
		else
			Error ("config file; GetFileAttributes (\"%s\") got error %u", filename, D_result);
	}
	if (D_result & FILE_ATTRIBUTE_DIRECTORY)
		Error ("config file \"%s\" is a directory", filename);

	h_file = CreateFile (filename, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);
	if (! h_file)
// and now it is error
		Error ("config file \"%s\" open was failed", filename);

	file_size = GetFileSize (h_file, 0);
	if (file_size > CONFIG_FILE_SIZE_MAX)
		Error ("config file \"%s\" size is %u, %u is max", file_size, CONFIG_FILE_SIZE_MAX);

	buffer = (char*)malloc (file_size);

	B_result = ReadFile (h_file, buffer, file_size, &bytes_read_num, 0);
	if (! B_result)
		goto free_memory;
	if (bytes_read_num != file_size)
		Error ("Config_Read () :  FileRead (\"%s\"), bytes read is %u instead of %u"), filename, bytes_read_num, file_size;

	Config_ParseBuffer (buffer, file_size);

free_memory:
	free (buffer);

	B_result = CloseHandle (h_file);
}

