#pragma once

#include "types.h"
#include "vec_str.h"
//#include <sstream>
//using namespace std;


enum
{
	CVAR_TYPE__NONE,
	CVAR_TYPE__BOOL,
	CVAR_TYPE__BYTE,
	CVAR_TYPE__UINT,
	CVAR_TYPES_NUM
};

struct cvar_t
{
	string name;
	uint type;
	void* var_ptr;
};


void Cvars_Init ();
void Cvars_Quit ();
void Cvars_Add (cvar_t& cvar);
void Cvars_Add_Bool (const char* name, bool* var_ptr);
void Cvars_Add_Byte (const char* name, byte* var_ptr);
void Cvars_Add_Uint (const char* name, uint* var_ptr);
bool Cvars_ParseCommandLine (vec_str_t& vec_str_line);

#define CVARS_ADD_BOOL(_var_) (Cvars_Add_Bool (#_var_, &_var_))
#define CVARS_ADD_BYTE(_var_) (Cvars_Add_Byte (#_var_, &_var_))
#define CVARS_ADD_UINT(_var_) (Cvars_Add_Uint (#_var_, &_var_))

