// by Alexander Ilyin
// actually global win-hooking must not be here, and be here must only the patching
// although from other sight - all is ok - unhook is necessary here, so why then not both - hook/unhook then ...

#include "dllmain.h"
#include <windows.h>
#include "error.h"
#include "../port.h"

// and that's what we have in WinXP :
// two functions, 'ChangeDisplaySettingsExA ()' and 'ChangeDisplaySettingsExW ()'; (both of them internally are requesting a same function)
// the other two, 'ChangeDisplaySettingsA ()' and 'ChangeDisplaySettingsW ()', are just requesting those two;
// currently hooking only 'ChangeDisplaySettingsExA ()', which also is requested by "ddraw.dll", so DirectDraw requests will also appear patched
// ('ChangeDisplaySettingsExW ()' have the same five bytes in its beginning, 8bff 55 8bec, so can also be patched with e9xxxxxxxx jump)


HINSTANCE gh_module = 0;
HHOOK gh_hook = 0;
bool patch_succeed = 0;
// init with any values, does not matters
byte g_password[16] = HOOKS_DLL_SAFETY_PASSWORD;
HANDLE gh_process = 0;
byte* address_return_ChangeDisplaySettingsExA = 0;
byte* address_return_GetCursorPos = 0;
bool is_patched_ChangeDisplaySettingsExA = 0;
HANDLE gh_dll_port_mapping = 0;
LPVOID dll_port_mapped_view = 0;
forced_resolution_refreshrate_t* forced_resolution_refreshrates = 0;
uint forced_resolution_refreshrates_num = 0;
//int mutex_Aside_ChangeDisplaySettingsExA = 0;
//bool g_refreshlock = 0;
//uint g_refreshlock_delay = 0;
config_settings_t g_config_settings = {0};
// it is our exe; some behaviour needs to be changed in this case
bool g_is_own_process = 0;


void Hooks_Disable ();
// disable it, when need test some, and avoid of hooking of all processes
#define ALLOW_GLOBAL_HOOK 1


//bool Screen_ModeRefresh_Find (int* ix, int width, int height, int bpp, int* refresh)
bool Modes_Find (int* ix, int width, int height, int bpp, int* refresh)
{
	uint i;
	forced_resolution_refreshrate_t* refreshrate;

	for (i = 0; i < forced_resolution_refreshrates_num; i++)
	{
		refreshrate = &forced_resolution_refreshrates[i];
		if (refreshrate->width != width)
			continue;
		if (refreshrate->height != height)
			continue;
		if (refreshrate->bpp != bpp)
			continue;
		if (ix)
			*ix = i;
		if (refresh)
			*refresh = refreshrate->refresh;
		return 1;
	}
	return 0;
}

void Modes_Unpack (byte* buffer, uint mapped_size)
{
//	byte* ptr;
	int struct_size;
//	uint size = 0;
	uint video_modes_num = 0;
	port_begin_t* port_begin;
	port_end_t* port_end;
	uint video_structures_size;
//	bool refreshlock = 0;
	config_settings_t* config_settings;

	g_config_settings.refreshlock = 0;
	g_config_settings.refreshlock_delay = 0;
	if (mapped_size < sizeof(port_begin_t) + sizeof(port_end_t))
		Error ("Modes_Unpack () :  file mapping size is 0x%04x, less than 0x%04x minimal necessary", mapped_size, sizeof(port_begin_t) + sizeof(port_end_t));

	port_begin = (port_begin_t*)buffer;
	if (port_begin->id0 != DLL_PORT_ID_0)
		Error ("Modes_Unpack () :  file id 0 is inequal");
	if (port_begin->id1 != DLL_PORT_ID_1)
		Error ("Modes_Unpack () :  file id 1 is inequal");
// check version before checking next two ids
	if (port_begin->version != PORT_VERSION)
		Error ("Modes_Unpack () :  port version is inequal, dll have %d, offered %d", PORT_VERSION, port_begin->version);
	if (port_begin->id2 != DLL_PORT_ID_2)
		Error ("Modes_Unpack () :  file id 2 is inequal");
	if (port_begin->id3 != DLL_PORT_ID_3)
		Error ("Modes_Unpack () :  file id 3 is inequal");
//	refreshlock = !! (port_begin->flags & PORT_FLAG_REFRESHLOCK);
	config_settings = &port_begin->config_settings;
	struct_size = port_begin->video_mode_struct_size;
	if (struct_size != sizeof(forced_resolution_refreshrate_t))
		Error ("Modes_Unpack () :  structure sizes are inequal");
	video_modes_num = port_begin->video_modes_num;
	buffer += sizeof(port_begin_t);

	video_structures_size = sizeof(forced_resolution_refreshrate_t) * video_modes_num;
	forced_resolution_refreshrates = (forced_resolution_refreshrate_t*)malloc (video_structures_size);
	if (! forced_resolution_refreshrates)
		Error ("Modes_Unpack () :  malloc (%u) failed", video_structures_size);
	memcpy (forced_resolution_refreshrates, buffer, video_structures_size);
	buffer += video_structures_size;

	port_end = (port_end_t*)buffer;
	if (port_end->id4 != DLL_PORT_ID_4)
		Error ("Modes_Unpack () :  file id 4 is inequal");
	if (port_end->id5 != DLL_PORT_ID_5)
		Error ("Modes_Unpack () :  file id 5 is inequal");
	if (port_end->id6 != DLL_PORT_ID_6)
		Error ("Modes_Unpack () :  file id 6 is inequal");
	if (port_end->id7 != DLL_PORT_ID_7)
		Error ("Modes_Unpack () :  file id 7 is inequal");
	buffer += sizeof(port_end_t);

//	g_refreshlock = refreshlock;
//	g_refreshlock_delay = refreshlock_delay;
	g_config_settings = *config_settings;
	forced_resolution_refreshrates_num = video_modes_num;
}

void Modes_Remove ()
{
	forced_resolution_refreshrates_num = 0;
	free (forced_resolution_refreshrates);
}


#define CHANGE_DISPLAY_SETTINGS_A 0

// no need ptr to ptr, because the values copying is made in a caller,
// so the caller have ability to read changes which made in a callee (it is in here)
// todo :  protect against too fast switching; but such thing must be done centralized; into exe perhaps better; like through pipe or some
//void Aside_ChangeDisplaySettingsA (LPDEVMODE lp_dev_mode, DWORD dw_flags)
//void Aside_ChangeDisplaySettingsA (LPDEVMODE* lp_dev_mode, DWORD dw_flags)
void __cdecl Aside_ChangeDisplaySettingsExA (LPCSTR lpsz_device_name, LPDEVMODEA lp_dev_mode, HWND hwnd, DWORD dw_flags, LPVOID lparam)
{
	bool result;
// *obsolete
	DEVMODE* devmode_ptr;
// simplificated; so must be protected by mutex !
	static DEVMODE devmode;
// oh how I messed; it will not work :)
//	static int mutex = 0;
	int refresh = 0;

// test/protection
//	Sleep (20 * 1000);
	Sleep (g_config_settings.refreshlock_delay);
// do not limit own process for a mode switch
	if (g_is_own_process)
		return;
	if (! g_config_settings.refreshlock)
		return;
//	devmode_ptr = *lp_dev_mode;
	devmode_ptr = lp_dev_mode;
	if (! devmode_ptr)
		return;
// all three must be on, otherwise we are not supporting a crap
	if (! (devmode_ptr->dmFields & DM_PELSWIDTH))
		return;
	if (! (devmode_ptr->dmFields & DM_PELSHEIGHT))
		return;
	if (! (devmode_ptr->dmFields & DM_BITSPERPEL))
		return;
//	goto force_freq;
//force_freq:
	result = Modes_Find (0, devmode_ptr->dmPelsWidth, devmode_ptr->dmPelsHeight, devmode_ptr->dmBitsPerPel, &refresh);
	if (! result)
		return;
	if (devmode_ptr->dmFields & DM_DISPLAYFREQUENCY)
	{
		if (devmode_ptr->dmDisplayFrequency == (uint)refresh)
			return;
	}
// lets protect the static structure
//	mutex++;
//	if (mutex != 1)
// just skip
//		goto decrement_mutex;
// what if the structure is in a read-only page; must copy
	memcpy (&devmode, devmode_ptr, sizeof(devmode));
	devmode.dmFields |= DM_DISPLAYFREQUENCY;
// test
//	devmode.dmDisplayFrequency = 85;
	devmode.dmDisplayFrequency = refresh;
//	*lp_dev_mode = &devmode;
	lp_dev_mode = &devmode;
//finish:
//decrement_mutex:
//	mutex--;
// test/protection
//	Sleep (10 * 1000);
}

__declspec(naked) void Call_ChangeDisplaySettingsExA ()
{
	__asm
	{
// *standard 5 bytes pattern
		mov edi, edi
		push ebp
		mov ebp, esp
		jmp [address_return_ChangeDisplaySettingsExA]
	}
}

//LONG ChangeDisplaySettings (LPDEVMODE lpDevMode, DWORD dwflags);
//WINUSERAPI LONG WINAPI ChangeDisplaySettingsExA (LPCSTR lpszDeviceName, LPDEVMODEA lpDevMode, HWND hwnd, DWORD dwflags, LPVOID lParam);
// name "bridge" seems is much near the intention than "tap"
__declspec(naked) void Bridge_ChangeDisplaySettingsExA ()
{
	static int mutex_counter = 0;
	__asm
	{
#if CHANGE_DISPLAY_SETTINGS_A
// copy 2 args by 12 bytes distance back
		push [esp + 8]
		push [esp + 8]
#else
// copy 5 args by 24 bytes distance back
		push [esp + 20]
		push [esp + 20]
		push [esp + 20]
		push [esp + 20]
		push [esp + 20]
#endif
// + redirect to C subroutine +
#if 0
// == old code; without copying ==
		lea eax, [esp + 4]
		pushad
		mov ebp, eax
		mov eax, [ebp + 4]
		push eax
//		mov eax, [ebp + 0]
		lea eax, [ebp + 0]
		push eax
#else
// would be strange, if my subr would spoil some registers, and 'ChangeDisplaySettingsExA ()' wouldn't
//		pushad
#endif
//		inc mutex_Aside_ChangeDisplaySettingsExA
//		mov eax, mutex_Aside_ChangeDisplaySettingsExA
		inc mutex_counter
		mov eax, mutex_counter
		cmp eax, 1
//		jnz reset_stack_after_call
//// hmmm, this actually isn't right :  we also should always deal with screen resolution switch time for a display protection reasons
//		jnz call_subr
// dual request ? - do not allow change, it is something potentially dangerous
		jnz change_failed
//proceed1:
		call Aside_ChangeDisplaySettingsExA
// *do not reset stack now; the values will be necessary, because they may be modified
//reset_stack_after_call:
//		add esp, 8
//		popad
// - redirect to C subroutine -
//// + copy function request on the stack +
//call_subr:
// put also new return address, and jump to it
		call Call_ChangeDisplaySettingsExA
//// - copy function request on the stack -
release_mutex:
		dec mutex_counter
// args copy is removed by __stdcall
#if CHANGE_DISPLAY_SETTINGS_A
// return and remove two args, also in __stdcall convention
		ret 8
change_failed:
// remove args
		add esp, 8
#else
// return and remove five args, also in __stdcall convention
		ret 20
change_failed:
// remove args
		add esp, 20
#endif
		mov eax, DISP_CHANGE_FAILED
		jmp release_mutex
	}
}

__declspec(naked) void Bridge_GetCursorPos ()
{
	__asm
	{
// + redirect to C subroutine +
		lea eax, [esp + 4]
		pushad
		popad
// - redirect to C subroutine -
// *standard 5 bytes pattern
		mov edi, edi
		push ebp
		mov ebp, esp
		jmp [address_return_GetCursorPos]
	}
}

void Hooks_Patch ()
{
	bool result;
	BOOL B_result;
	byte pattern_patch_standard[5] = {0x8b, 0xff, 0x55, 0x8b, 0xec};
	ulong difference;
	byte buffer[64];
	byte* address;
	DWORD num_bytes = -1;

//	__asm int 3;
	Assert(gh_process);

#if 0
	GetCursorPos (0);
	address = (byte*)GetCursorPos;
	result = ! memcmp (address, pattern_patch_standard, 5);
	if (! result)
// cannot patch, or is already patched
		return;

	address_return_GetCursorPos = address + 5;
	difference = (byte*)Bridge_GetCursorPos - address_return_GetCursorPos;
	buffer[0] = 0xe9;
	*(long*)&buffer[1] = difference;
	B_result = WriteProcessMemory (gh_process, address, buffer, 5, &num_bytes);
	if (! B_result)
		return;
	GetCursorPos (0);
#endif

#if 1
//	ChangeDisplaySettingsExA (0, 0);
	address = (byte*)ChangeDisplaySettingsExA;
	result = ! memcmp (address, pattern_patch_standard, 5);
	if (! result)
// cannot patch, or is already patched
		return;

	address_return_ChangeDisplaySettingsExA = address + 5;
	difference = (byte*)Bridge_ChangeDisplaySettingsExA - address_return_ChangeDisplaySettingsExA;
	buffer[0] = 0xe9;
	*(long*)&buffer[1] = difference;
	B_result = WriteProcessMemory (gh_process, address, buffer, 5, &num_bytes);
	if (! B_result)
		return;
	is_patched_ChangeDisplaySettingsExA = 1;
//	ChangeDisplaySettingsExA (0, 0);
#endif

	patch_succeed = 1;
}

void Hooks_Unpatch ()
{
//	bool result;
	BOOL B_result;
	byte pattern_patch_standard[5] = {0x8b, 0xff, 0x55, 0x8b, 0xec};
//	ulong difference;
//	byte buffer[64];
	byte* address;
	DWORD num_bytes = -1;

//	__asm int 3;
	Assert(gh_process);

#if 1
	if (! is_patched_ChangeDisplaySettingsExA)
		goto finish;
	address = (byte*)ChangeDisplaySettingsExA;
	B_result = WriteProcessMemory (gh_process, address, pattern_patch_standard, 5, &num_bytes);
	if (! B_result)
		return;
	is_patched_ChangeDisplaySettingsExA = 0;
//	ChangeDisplaySettingsExA (0, 0);
#endif

finish:
	return;
}

// must handle a process start
LRESULT CALLBACK GetMsgProc (int hook_code, WPARAM w_param, LPARAM l_param)
{
	LRESULT lresult;
	MSG* msg;

//	__asm int 3;
//	Assert(gh_hook);
// 'gh_hook' will be 0 for non initial thread, but it doesn't matters, because Win NT ignores it
	lresult = CallNextHookEx (gh_hook, hook_code, w_param, l_param);
	if (hook_code != HC_ACTION)
		goto finish;
	Assert(l_param);
	msg = (MSG*)l_param;

finish:
//	return 0;
	return lresult;
}

// + IPC +

// not a pipe actually, because no stream, but a static array
// lets read once, and later do not open file anymore (I am not insisting, but just to not slowdown much an intercepted functions)
bool Pipe_Init ()
{
//	bool result;
	bool return_result = 0;
	BOOL B_result;
//	DWORD D_result;
	uint mapped_size = 0;
//	void* buffer = 0;
	MEMORY_BASIC_INFORMATION memory_basic_information;

	gh_dll_port_mapping = OpenFileMapping (FILE_MAP_READ, 0, DLL_PORT_FILE_MAPPING_NAME);
	if (! gh_dll_port_mapping)
		Error ("Pipe_Init () :  OpenFileMapping (\"%s\") failed", DLL_PORT_FILE_MAPPING_NAME);
//	D_result = GetLastError ();
//	if (D_result == ERROR_ALREADY_EXISTS)
//		Error ("Pipe_Init () :  mapping object \"%s\" already exist", DLL_PORT_FILE_MAPPING_NAME);

	dll_port_mapped_view = MapViewOfFile (gh_dll_port_mapping, FILE_MAP_READ, 0, 0, 0);
	if (! dll_port_mapped_view)
		Error ("Pipe_Init () :  MapViewOfFile () failed");

//	Screen_WholeStruct_Pack (dll_port_mapped_view);
// bad, it returns mapped size, and not real filesize
	VirtualQuery (dll_port_mapped_view, &memory_basic_information, sizeof(memory_basic_information));
	mapped_size = memory_basic_information.RegionSize;
// returns -1
//	size = GetFileSize (gh_dll_port_mapping, 0);

// appears the 0 size is normal; happens perhaps when no active exe
//	if (mapped_size < 0x10)
	if (! mapped_size)
		goto unmap;
	Modes_Unpack ((byte*)dll_port_mapped_view, mapped_size);
	return_result = 1;

unmap:
	Assert(dll_port_mapped_view);
	B_result = UnmapViewOfFile (dll_port_mapped_view);
	Assert(B_result);
	dll_port_mapped_view = 0;

	Assert(gh_dll_port_mapping);
	B_result = CloseHandle (gh_dll_port_mapping);
	Assert(B_result);
	gh_dll_port_mapping = 0;

	return return_result;
}

void Pipe_Quit ()
{
	Modes_Remove ();
}

// - IPC -

// entry point
BOOL APIENTRY DllMain (HINSTANCE h_module, DWORD reason, PVOID reserved)
{
	bool result;
	DWORD id;
	BOOL B_result;

	switch (reason)
	{
	case DLL_PROCESS_ATTACH:
//		__asm int 3;
		memset (&g_config_settings, 0, sizeof(g_config_settings));
		Assert(h_module);
		gh_module = h_module;
		id = GetCurrentProcessId ();
		Assert(id);
		gh_process = OpenProcess (PROCESS_ALL_ACCESS, 0, id);
		Assert(gh_process);
// need pipe first of all; there goes all setings through
		result = Pipe_Init ();
		if (! result)
			return 0;
		Hooks_Patch ();
//		result = Hooks_Patch ();
//		if (! result)
		if (! patch_succeed)
		{
			Pipe_Quit ();
// this mostly means, that old patch still is in work
			Error ("DllMain () :  patch does not succeed");
			return 0;
		}
		break;
	case DLL_PROCESS_DETACH:
		Assert(gh_process);
// if we have hooked, then we must unhook, if not unhooked yet;
// the exe actually already requested unhook, if the exe is not crashed
		if (gh_hook)
			Hooks_Disable ();
		Hooks_Unpatch ();
		B_result = CloseHandle (gh_process);
		Assert(B_result);
		gh_process = 0;
		break;
	}

	return 1;
}

//bool __stdcall Hooks_Activate ()
bool Hooks_Enable ()
{
//	bool result;

// request a function, which will make less slow down to system performance, but would be requested at process start time.
// 'WH_GETMESSAGE' appears is enough rare requested, and also immediately requested after our start,
// but sometimes it is long time not requested, so the dll remains not unloaded.
// as some example - 'WM_DISPLAYCHANGE' not goes through it.
#if ALLOW_GLOBAL_HOOK
	Assert(gh_module);
	gh_hook = ::SetWindowsHookEx (WH_GETMESSAGE, (HOOKPROC)GetMsgProc, gh_module, 0);
#else
	DWORD thread_id;
	thread_id = GetCurrentThreadId ();
	gh_hook = ::SetWindowsHookEx (WH_GETMESSAGE, (HOOKPROC)GetMsgProc, 0, thread_id);
#endif
	Assert(gh_hook);
	return 1;
}

void Hooks_Disable ()
{
	BOOL B_result;

	Assert(gh_hook);
	B_result = UnhookWindowsHookEx (gh_hook);
	Assert(B_result);
	gh_hook = 0;
}

// make self to be loaded in any process
// return 1, if patch is possible and is succeed
bool __stdcall Hooks_Init (byte* password)
//void __stdcall Hooks_Install ()
{
	bool result;

	Assert(password);
// do not allow to go with wrong password, for safety reasons
	result = ! memcmp (password, g_password, sizeof(g_password));
//	if (! result)
//		return 0;
	Assert(result);
	g_is_own_process = 1;
	if (! patch_succeed)
		return 0;
	if (gh_hook)
		return 0;
	result = Hooks_Enable ();
	return result;
}

// stop self to be loaded in every process
// maybe also todo unpatch (?), although that isn't so easy
void __stdcall Hooks_Quit (byte* password)
//void __stdcall Hooks_Remove ()
{
	bool result;

	Assert(password);
// do not allow to go with wrong password, for safety reasons
	result = ! memcmp (password, g_password, sizeof(g_password));
//	if (! result)
//		return 0;
	Assert(result);
	if (! gh_hook)
		return;
	Hooks_Disable ();
}

