// by Alexander Ilyin
// errors handling
// belongs at "Drag Watcher" project

#include "error.h"
#include <windows.h>
//#include <stdlib.h>
#include <string.h>
#include <stdio.h>


// todo :  do not display an error for every process, but just only for the initial
bool Error_IsInitialProcess ()
{
//	static char filename[256];
	byte* base_address0;
	byte* base_address1;

	base_address0 = (byte*)GetModuleHandle (0);
	base_address1 = (byte*)GetModuleHandle ("Win_Resident_Tools.exe");
	if (! base_address0)
		return 0;
	if (! base_address1)
		return 0;
//	D_result = GetModuleFileName ((HMODULE)base_address, filename, sizeof(filename));
//	if (! D_result)
//		;
	if (base_address0 == base_address1)
		return 1;
	return 0;
}

void Error_Log_Print (const char* str)
{
	HANDLE h_log_file;
	int string_length;
	BOOL B_result;
	DWORD bytes_written = 0;

	string_length = strlen (str);
	h_log_file = CreateFile ("C:\\Program Files\\Win_Resident_Tools\\error_log_dll.txt", GENERIC_WRITE, FILE_SHARE_READ, 0, OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0);
	if (h_log_file == INVALID_HANDLE_VALUE) 
		return;
	DWORD D_result = SetFilePointer (h_log_file, 0, NULL, FILE_END);
// :P
//	if (D_result == 0xffffffff)
//		Error ("Error_Log_Print () :  'SetFilePointer ()' fails");
	B_result = WriteFile (h_log_file, str, string_length, &bytes_written, 0);
// will be inconsistent '\r', but I wouldn't care
	B_result = WriteFile (h_log_file, "\r\n", 2, &bytes_written, 0);
	CloseHandle (h_log_file);
}

//terminates with error code 1, printing message
void Error (char* format, ...)
{
	va_list arglist;
	static char exit_message[512];
	bool is_initial_process;

//	strcpy (exit_message,"\nError: ");
	va_start(arglist, format);
//	vsprintf (exit_message + strlen(exit_message), format, arglist);
	vsprintf (exit_message, format, arglist);
	va_end(arglist);

//	printf (exit_message);

	is_initial_process = Error_IsInitialProcess ();

	if (is_initial_process)
//		MessageBox (0, exit_message, 0, MB_OK);
		MessageBox (0, exit_message, "Windows Resident Tools - Error", MB_OK);
	else
	{
		static char dir[512];
		DWORD D_result;

		D_result = GetCurrentDirectory (sizeof(dir), dir);
		if (D_result)
		{
			Error_Log_Print ("Current working directory :  ");
			Error_Log_Print (dir);
			Error_Log_Print ("\n");
		}
		Error_Log_Print (exit_message);
		Error_Log_Print ("\n");
	}

// *will call all declared by 'atexit()'
	exit(1);
}

// error, but not exit the process; continue
void Error_NoExit (char* format, ...)
{
va_list arglist;
char exit_message[256];

	strcpy (exit_message,"\nError: ");
	va_start(arglist, format);
	vsprintf (exit_message + strlen(exit_message), format, arglist);
	va_end(arglist);

	printf (exit_message);

	MessageBox (0, exit_message, 0, MB_OK);
}

void _Assert (int expr, char* expr_text, char* filename, int linenum)
{
	if (! (expr))
	{
		Error ("Assertion failed: %s, file %s, line %d", expr_text, filename, linenum);
	}
}

