#pragma once

// by Alexander Ilyin
// errors handling

#include "config.h"


#if ! defined (ERROR_WITH_LOGFILE)
#define ERROR_WITH_LOGFILE 0
#endif

#if ERROR_WITH_LOGFILE
void Error_Log_Print (const char* str);
void Error_Log_Printf (const char* format, ...);
#endif
void Error (const char* fmt, ...);
void ErrorReport (const char* format, ...);

void _Assert (int expr, const char* expr_text, const char* filename, int linenum);

// ways to bring expression to boolean :  MSVC 6.0 SP 6 compiler compiles '!! expression' short and properly;
// 'expression || 0' compiles into much bigger code
#define Assert(_expression_) _Assert(!! (_expression_), #_expression_, __FILE__, __LINE__)

// *MSVC 6.0 does not eat ellipsis, nor knows '__FUNCTION__'
#if _MSC_VER >= 1300
// eeeh, undefine it in "wingdi.h" - it is nonsense to use such important define for some garbage
//#undef ERROR
#define ERROR(_format_, ...) {Error (__FUNCTION__" () :  "_format_, __VA_ARGS__);}
#define REPORT_ERROR(_format_, ...) {ReportError (__FUNCTION__" () :  "_format_, __VA_ARGS__);}
#endif

