// by Alexander Ilyin

// ___ stack for tooltips :  TTM_SETDELAYTIME, TTDT_AUTOPOP

//#define _WIN32_WINNT 0x0501
//#define WINVER 0x0501

#include "main.h"
#include "trayicon.h"
//#include <assert.h>
//#include <stdio.h>
#include "screen.h"
#include "hotkeys.h"
#include "error.h"
#include "resource.h"
#include "config.h"
#include "configuration.h"
#include "winhook.h"
#include "dll/dllmain.h"
#include "port.h"
#include <commctrl.h>
#include "wnd_console.h"
#include "wnd_volume.h"
#include "volume.h"
#include "cvars.h"
#include "notify.h"
#include "measure.h"


// we are moving forward, not bothering with old stuff :)
// hmmm, about what I ? :)
#ifndef SPI_GETMOUSESPEED
#define SPI_GETMOUSESPEED 0x0070
#endif
#ifndef SPI_SETMOUSESPEED
#define SPI_SETMOUSESPEED 0x0071
#endif

#define MOUSE_CONFIGURATION 0

//WNDPROC WndProc;
LRESULT APIENTRY WndProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
DWORD WINAPI RevisingThread (VOID*);
WNDPROC WndProc_Org;
HWND hwnd_info_tray_icon = 0;
HMENU tray_icon_menu = 0;
HANDLE event__thread_exit_request = 0;
//long revise_wait_ms = 1000;
//long revise_wait_ms = 500;
// on 100 ms, "explorer.exe" affection is unnoticable anyhow
long revise_wait_ms = 100;
// low values like 0, do overuse cpu not here, but in "explorer.exe"; there/here ~ 4/1
//long revise_wait_ms = 0;
// protection against double starting
HANDLE h_winrestools_process_global_mutex = 0;
byte hooks_dll_password[16] = HOOKS_DLL_SAFETY_PASSWORD;
HMODULE gh_dll = 0;
HMODULE gh_kernel32 = 0;
HMODULE gh_user32 = 0;
HMODULE gh_shell32 = 0;
//HMODULE gh_psapi = 0;
//bool (__stdcall* Hooks_Init) (byte*) = 0;
//void (__stdcall* Hooks_Quit) (byte*) = 0;
Hooks_Init_t Hooks_Init = 0;
Hooks_Quit_t Hooks_Quit = 0;
HANDLE gh_dll_port_mapping = 0;
LPVOID dll_port_mapped_view = 0;
// *from eMule
//const UINT WM_TASKBARCREATED = ::RegisterWindowMessage (_T("TaskbarCreated"));
UINT WM_TASKBARCREATED = 0;

// + config +
//bool g_refreshlock = 0;
// delay before switch screen mode (necessary only for safety, and may be used for debug purposes); normally must be 0
//uint g_refreshlock_delay = 0;
config_settings_t g_config_settings = {0};
//ulong hotkey_modifier = 0;
// - config -

enum
{
	ICON_MENU_ID__NONE,
	ICON_MENU_ID__QUIT,
	ICON_MENU_ID__CONSOLE,
	ICON_MENU_IDS_NUM,
};

#define REDEFINE_CURRENT_WORKING_DIRECTORY 1


// +++ research +++

#define RESEARCH_WND_MESSAGES 0

#if RESEARCH_WND_MESSAGES

bool record_msgs = 0;

void MsgRecord_String (char* str_msg)
{
	FILE* f;

//	if (! record_msgs)
//		return;
	f = fopen ("msgs_log.txt", "a");
	if (! f)
		return;
	fprintf (f, "%s\n", str_msg);
	fclose (f);
}

void MsgRecord_Msg (uint msg)
{
	char buffer[64];

	if (! record_msgs)
		return;
//	sprintf (buffer, "%u", msg);
	sprintf (buffer, "%04x", msg);
	MsgRecord_String (buffer);
}

void MsgRecord_Start (void*)
{
// separate
	MsgRecord_String ("++++++++++");
	record_msgs = 1;
}

void MsgRecord_Stop (void*)
{
	record_msgs = 0;
// separate
	MsgRecord_String ("----------");
}

void Cursor_Show (void*)
{
// *but in really it must be paired with the 'ShowCursor (1);'
	ShowCursor (0);
}

void Debug_HotkeysAdd ()
{
	bool r;
	hotkey_info_t hotkey_info;

	memset (&hotkey_info, 0, sizeof(hotkey_info));
	hotkey_info.modifier = MOD_CONTROL | MOD_ALT;
	hotkey_info.key_name[1] = 0;

	hotkey_info.vkey_code = 'A';
	hotkey_info.function = MsgRecord_Start;
	hotkey_info.key_name[0] = hotkey_info.vkey_code;
	r = hot_keys->Add (&hotkey_info, 0, 0);
	if (! r)
		Error ("adding hot key '%c' failed", hotkey_info.vkey_code);
	hotkey_info.vkey_code = 'S';
	hotkey_info.function = MsgRecord_Stop;
	r = hot_keys->Add (&hotkey_info, 0, 0);
	if (! r)
		Error ("adding hot key '%c' failed", hotkey_info.vkey_code);
#if 0
// one more test
	hotkey_info.vkey_code = 'Y';
	hotkey_info.function = Cursor_Show;
	r = hot_keys->Add (&hotkey_info, 0, 0);
	if (! r)
		Error ("adding hot key '%c' failed", hotkey_info.vkey_code);
#endif
}

#endif

// --- research ---

void Main_MouseSettings_Set ()
{
	BOOL B_result;
//	int params[3];
	int mouse_speed;

	B_result = SystemParametersInfo (SPI_GETMOUSESPEED, 0, (VOID*)&mouse_speed, 0);
// no, hardly limited into 1-20, by some smart guy
//	__asm int 1
// NtUserSystemParametersInfo ()
// the speed is limited to 20 in "win32k.sys", thanks Microsoft again
	B_result = SystemParametersInfo (SPI_SETMOUSESPEED, 0, (VOID*)10, 0);
//	B_result = SystemParametersInfo (SPI_GETMOUSE, 0, params, 0);
//	B_result = SystemParametersInfo (SPI_SETMOUSE, 0, params, 0);
}

bool DllHooks_Port_Init (bool refreshlock)
//bool DllHooks_Port_Init (uint size, void** buffer)
{
	bool r;
	DWORD D_result;
	uint size = 0;
//	void* buffer = 0;

	r = Screen_WholeStruct_GetSize (&size, refreshlock);

	gh_dll_port_mapping = CreateFileMapping (INVALID_HANDLE_VALUE, 0, PAGE_READWRITE, 0, size, DLL_PORT_FILE_MAPPING_NAME);
	if (! gh_dll_port_mapping)
	{
		ErrorReport ("DllHooks_Port_Init () :  CreateFileMapping (\"%s\") failed", DLL_PORT_FILE_MAPPING_NAME);
		return 0;
	}
	D_result = GetLastError ();
	if (D_result == ERROR_ALREADY_EXISTS)
	{
		ErrorReport ("DllHooks_Port_Init () :  mapping object \"%s\" already exist", DLL_PORT_FILE_MAPPING_NAME);
		return 0;
	}

	dll_port_mapped_view = MapViewOfFile (gh_dll_port_mapping, FILE_MAP_WRITE, 0, 0, 0);
	if (! dll_port_mapped_view)
	{
		ErrorReport ("DllHooks_Port_Init () :  MapViewOfFile () failed");
		return 0;
	}

	Screen_WholeStruct_Pack (dll_port_mapped_view, refreshlock);

	return 1;
}

void DllHooks_Port_Quit ()
{
	BOOL B_result;

//	Assert(dll_port_mapped_view);
	if (dll_port_mapped_view)
	{
		B_result = UnmapViewOfFile (dll_port_mapped_view);
		Assert(B_result);
		dll_port_mapped_view = 0;
	}

//	Assert(gh_dll_port_mapping);
	if (gh_dll_port_mapping)
	{
		B_result = CloseHandle (gh_dll_port_mapping);
		Assert(B_result);
		gh_dll_port_mapping = 0;
	}

	return;
}

// simplificated :  library load and hooks activation are both here
bool DllHooks_Init ()
{
	bool r;
//	BOOL B_result;
//	DWORD protect_old;

//	GetCursorPos (0);
//	B_result = VirtualProtect (GetCursorPos, 0x100, PAGE_EXECUTE_READWRITE, &protect_old);
//	*(byte*)GetCursorPos = 0x8b;
//	*(byte*)GetCursorPos = 0xcc;

// if already is loaded, then not fails, but returns the same address
	gh_dll = LoadLibrary (HOOKS_DLL_NAME);
	if (! gh_dll)
	{
		ErrorReport ("DllHooks_Init () :  LoadLibrary (\"%s\") failed\nPossibly \"%s.dll\" file cannot be found.", HOOKS_DLL_NAME, HOOKS_DLL_NAME);
		return 0;
	}
// no !  this does dereferences the ptr
//	*(void**)Hooks_Init = GetProcAddress (gh_dll, "Hooks_Init");
// does not compile
//	(void*)Hooks_Init = (void*)GetProcAddress (gh_dll, "Hooks_Init");
	Hooks_Init = (Hooks_Init_t)GetProcAddress (gh_dll, "Hooks_Init");
	if (! Hooks_Init)
	{
		ErrorReport ("DllHooks_Init () :  getting function \"%s\" ptr failed", "Hooks_Init");
		return 0;
	}
	Hooks_Quit = (Hooks_Quit_t)GetProcAddress (gh_dll, "Hooks_Quit");
	if (! Hooks_Quit)
	{
		ErrorReport ("DllHooks_Init () :  getting function \"%s\" ptr failed", "Hooks_Quit");
		return 0;
	}

	r = Hooks_Init (hooks_dll_password);
	if (! r)
	{
		ErrorReport ("DllHooks_Init () :  Hooks_Init () failed");
		return 0;
	}

	return r;
}

void DllHooks_Quit ()
{
	BOOL B_result;

	if (Hooks_Quit)
		Hooks_Quit (hooks_dll_password);
	if (gh_dll)
	{
		B_result = FreeLibrary (gh_dll);
		if (! B_result)
			Error ("DllHooks_Quit () :  FreeLibrary (\"%s\") failed", HOOKS_DLL_NAME);
		gh_dll = 0;
	}
}

#if REDEFINE_CURRENT_WORKING_DIRECTORY
// 'IopParseFile (..., ObjectName, RemainingName, ...)' -> 'IopParseDevice ()' do not parse
// 'ObpLookupObjectName ()' does parse some
// maybe is possible to find some by 'OBJECT_ATTRIBUTES::RootDirectory', but perhaps will be much easier to parse the filename by self

// if is starting from "HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\Run", then 'cmd_line' of 'WinMain' is empty, and current working directory is "C:\Documents and Settings\Administrator"; same for MSVC 6 and for 8
// so have to define the working directory by ourself
bool DefineWorkingDirectory ()
{
	BOOL B_result;
	DWORD D_result;
	WCHAR filepath[1024];
	wchar_t* r_wc;

#if 0
	char test_filename[1024];
	D_result = GetCurrentDirectory (sizeof(test_filename), test_filename);
	if (D_result)
		ErrorReport ("current directory is\n\"%s\"", test_filename);
	else
		ErrorReport ("GetCurrentDirectory () failed");
//	return 1;
#endif

// lets go at classic 'VirtualQuery ()'; though don't even need it; 'GetModuleFileName ()' works good without a given 'HMODULE'

	D_result = GetModuleFileNameW (0, filepath, sizeof(filepath));
	if (! D_result)
		Error ("GetModuleFileNameW () failed");

	r_wc = wcsrchr (filepath, L'\\');
	if (! r_wc)
		Error ("DefineWorkingDirectory () :  backslash is not found in received filepath\n\"%S\"", filepath);
	if (r_wc == filepath)
		Error ("DefineWorkingDirectory () :  can't find a directory in received filepath\n\"%S\"", filepath);

// truncate the path here, before the filename; the necessary directory should form then
	*r_wc = 0;
	B_result = SetCurrentDirectoryW (filepath);
//	if (! B_result)
//		Error ("DefineWorkingDirectory () :  SetCurrentDirectoryW () has failed for the directory\n\"%S\"", filepath);

	return 1;
}
#endif

int WINAPI WinMain (HINSTANCE h_instance, HINSTANCE h_prev_instance, LPSTR cmd_line, int n_show_cmd)
{
	bool r;
	BOOL B_result;
	DWORD D_value;
// *not mandatory necessary, but it is short and comfort
	HWND hwnd_icon = 0;
	MSG msg;
	WNDCLASS wc;
	ATOM atom;
	HANDLE h_thread;
	DWORD thread_id;
//	uint i;

// look 'finish:' label, to find out for what is that
// + cleanup finish conditions +
	h_thread = 0;
	event__thread_exit_request = 0;
	tray_icon_menu = 0;
// - cleanup finish conditions -

	memset (&g_config_settings, 0, sizeof(g_config_settings));
// the module must be already loaded, for the 'GetModuleHandle ()' way
	gh_kernel32 = GetModuleHandle (TEXT("KERNEL32"));
	Assert(gh_kernel32);
	gh_user32 = GetModuleHandle (TEXT("USER32"));
	Assert(gh_user32);
	gh_shell32 = GetModuleHandle (TEXT("SHELL32"));
	Assert(gh_shell32);
#if 0
	gh_psapi = GetModuleHandle (TEXT("PSAPI"));
	if (! gh_psapi)
		gh_psapi = LoadLibrary (TEXT("PSAPI"));
	Assert(gh_psapi);
#endif

#if REDEFINE_CURRENT_WORKING_DIRECTORY
	r = DefineWorkingDirectory ();
#endif

// protect against double starting; it may be dangerous, if refreshlock is on
	h_winrestools_process_global_mutex = CreateMutex (0, 1, PROTECTION_MUTEX_NAME);
// succeed even if mutex exist (yes, it is wrong, I know)
	if (! h_winrestools_process_global_mutex)
		Error ("creation of \"%s\" mutex has failed", PROTECTION_MUTEX_NAME);
	D_value = GetLastError ();
	if (D_value == ERROR_ALREADY_EXISTS)
		Error ("The process perhaps already is running.\nCreation of \"%s\" mutex has failed.\nExiting.", PROTECTION_MUTEX_NAME);

// register all cvars
	Cvars_Init ();

// test
//	Screen_ModeRefresh_Add (1024, 768, 32, 85);
//	refreshlock = 1;

// *necessary for config reading
//	hot_keys = new CHotKeys (hwnd_icon);
//	if (! hot_keys)
//	{
//		Error ("new CHotKeys () failed");
//		ErrorReport ("new CHotKeys () failed");
//		goto destroy_window;
//	}
//	Hotkeys_Init (hwnd_icon);
	Hotkeys_Init ();

//	config_ParsingSubr_Plain = Config_ParseString_MainConfig_;
	config_ParsingSubr_Plain = 0;
	config_ParsingSubr = Config_ParseString_MainConfig;
	Config_Read ("config.cfg");
	config_ParsingSubr_Plain = Screen_ParseString_ModesConfig;
//	config_ParsingSubr = Screen_ParseString_ModesConfig;
	config_ParsingSubr = 0;
	Config_Read ("modes.cfg");

#if RESEARCH_WND_MESSAGES
	Debug_HotkeysAdd ();
#endif

// +++ dll +++
// unload old dll, if loaded
	gh_dll = GetModuleHandle (HOOKS_DLL_NAME);
	if (gh_dll)
		DllHooks_Quit ();

// init pipe, but after unload old dll
// actually, needs video modes already been read from modes list config file
	r = DllHooks_Port_Init (g_config_settings.refreshlock);
//	r = DllHooks_Port_Init (size, &buffer);
	if (! r)
		goto finish;

// load dll
	r = DllHooks_Init ();
	if (! r)
//		goto quit_port_dll;
		goto finish;
// --- dll ---

// ====== don't use 'return' below; use 'goto finish' instead (it will unload the dll) ======

#if MOUSE_CONFIGURATION
	Main_MouseSettings_Set ();
#endif

// this window is the mostly important
	r = WndConsole_Init (h_instance);
	if (! r)
	{
		ErrorReport ("creation of console window has failed");
//		goto quit_dll;
		goto finish;
	}
// test
//	WndConsole_Show ();
//	WndConsole_Hide ();
//	Notify_Errorf ("hello wrld");

// medium importance window
	HICON icon;
	icon = LoadIcon (h_instance, MAKEINTRESOURCE(IDI_ICON1));

//	wc.style = 0;
	wc.style = CS_DBLCLKS;
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = h_instance;
	wc.hIcon = icon;
	wc.hCursor = 0;
	wc.hbrBackground = 0;
	wc.lpszMenuName = 0;
	wc.lpszClassName = "Win_Resident_Tools_notify_icon_class";

	atom = RegisterClass (&wc);
	if (! atom)
	{
		ErrorReport ("WinMain () :  RegisterClass () has failed");
		goto finish;
	}

	hwnd_icon = CreateWindow
		(
// it is greater than 0xc000 (not global atom ?), but all works ok :)
			(char*)atom,
			"Windows Resident Tools notify icon window",
//			0,
			WS_OVERLAPPEDWINDOW,
//			WS_OVERLAPPEDWINDOW | WS_TABSTOP,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			0,
			0,
			h_instance,
			0
		);
	if (! hwnd_icon)
	{
		ErrorReport ("WinMain () :  CreateWindow () for the notification icon has failed");
		goto finish;
	}
	hwnd_info_tray_icon = hwnd_icon;

// low importance window
	r = WndVolume_Init (h_instance);
	if (! r)
// althogh this is secondary window, but while is exiting in case of this window allocation failure, show explicit error
// (later it should just be displayed in console, and don't do exit)
	{
		ErrorReport ("creation of volume window has failed");
		goto finish;
	}

// *unfinished
	WndVolume_SetScale (-1);
//	WndVolume_SetScale (1);
//	WndVolume_SetScale (3);
	WndVolume_OffscreenBitmap_Allocate ();
//	WndVolume_Show ();
//	WndVolume_Display ();
//	WndVolume_SetValue (0x3800);
	WndVolume_SetValue (0x8200);
// update volume value for the volume indicator window
	Volume_Manage (0, 0);

// without that the window will not be displayed
//	ShowWindow (hwnd_icon, n_show_cmd);
//	UpdateWindow (hwnd_icon);

//	tray_icon_menu = CreateMenu ();
	tray_icon_menu = CreatePopupMenu ();
// so need 'MF_OWNERDRAW' to get bold font, as I understand
	B_result = AppendMenu (tray_icon_menu, MF_ENABLED | MF_STRING, ICON_MENU_ID__CONSOLE, "Own events console");
// I don't see any highliting
//	B_result = AppendMenu (tray_icon_menu, MF_ENABLED | MF_STRING | MF_HILITE, ICON_MENU_ID__CONSOLE, "Own events console");
// no bold text also
//	B_result = AppendMenu (tray_icon_menu, MF_ENABLED | MF_STRING | MF_DEFAULT, ICON_MENU_ID__CONSOLE, "Own events console");
	B_result = AppendMenu (tray_icon_menu, MF_SEPARATOR, 0, 0);
	B_result = AppendMenu (tray_icon_menu, MF_ENABLED | MF_STRING, ICON_MENU_ID__QUIT, "Quit");
//	B_result = AppendMenu (tray_icon_menu, MF_ENABLED | MF_STRING, ICON_MENU_ID__QUIT, "_________Quit__________");

// it perhaps is something other, than the the thing I wished (I wished bold text)
// wrong thing; it is blue highlight
//	B_result = HiliteMenuItem (0, tray_icon_menu, ICON_MENU_ID__CONSOLE, MF_HILITE);
// window handle is necessary; hehe, it isn't bound yet
//	B_result = HiliteMenuItem (hwnd_icon, tray_icon_menu, ICON_MENU_ID__CONSOLE, MF_HILITE);

	B_result = SetMenuDefaultItem (tray_icon_menu, ICON_MENU_ID__CONSOLE, 0);

// this message will be registered when ...
// "When the taskbar is created, it registers a message with the TaskbarCreated string and then broadcasts this message to all top-level windows."
// hmmm, this function will not tell - was the message registered or not
	WM_TASKBARCREATED = ::RegisterWindowMessage (_T("TaskbarCreated"));

// when this fails, that ordinary means, that the taskbar isn't created yet;
// even if wait here until it will be created, and then re-request this again, then still will be WM_TASKBARCREATED, and accordingly - 'TrayIcon_Init ()' request;
// so better would be to not retry and not wait some, but just continue
	r = TrayIcon_Init (hwnd_icon);
//	i = TrayIcon_Init (hwnd_icon);
//	TrayIcon_Init (hwnd_icon);
// it is not an error, it's normal; and don't even put unnecessary/meaningless string into the console log;
// if this will happen, the systray icon will be peacefully created at WM_TASKBARCREATED time
// no, I've changed 'TrayIcon_Init ()' return value - now it will be 0 in case of a real error, so lets use it
#if 1
	if (! r)
//	if (! i)
	{
// tray icon doesn't reports an error
		ErrorReport ("tray icon initialization has failed");
		goto finish;
	}
#endif
//	TrayIcon_Update (hwnd_icon, "update");
//	Sleep (3000);

	event__thread_exit_request = CreateEvent (0, 1, 0, 0);
	if (! event__thread_exit_request)
	{
		ErrorReport ("CreateEvent () for the thread exit has failed");
		goto finish;
	}
// *the thread will use 'hwnd_info_tray_icon'
	h_thread = CreateThread (0, 0, RevisingThread, 0, 0, &thread_id);
	if (! h_thread)
	{
		ErrorReport ("CreateThread () for the revising thread has failed");
		goto finish;
	}

	Measure_Init ();

//	Hotkeys_Register ();
	hot_keys->SetHwnd (hwnd_icon);
	r = hot_keys->ActivateAll ();
	if (! r)
	{
//		ErrorReport ("hotkeys registering failed");
		Error_Log_Print ("hotkeys registering failed\n");
//		goto destroy_window;
		goto finish;
	}

// not in use
//	WinHook_Init ();

// *'WndProc ()' does receive most messages without going through this loop
// 'GetMessage ()' is tribool; returns 0 on WM_QUIT; WM_QUIT is intended for this loop termination, and not for transfering it to 'WndProc ()'
// this loop looks for me better than lets say a loop with three 'PeekMessage ()' for each window
//	while (B_result = GetMessage (&msg, 0, 0, 0), B_result == 1)
	while (B_result = GetMessage (&msg, 0, 0, 0))
	{
		if (B_result != 1)
		{
			Error_Log_Printf ("WinMain () :  GetMessage () has returned %08x\n", B_result);
			break;
		}

		TranslateMessage (&msg);
		DispatchMessage (&msg);

		B_result = GetExitCodeThread (h_thread, &D_value);
		if (! B_result)
		{
			Error_Log_Print ("WinMain () :  GetExitCodeThread () for the revising thread has failed\n");
			break;
		}
		if (D_value != STILL_ACTIVE)
		{
			if (D_value)
				Error_Log_Printf ("WinMain () :  revising thread has exited with an error code %08x\n", D_value);
			break;
		}
	}

// in case, if WM_QUIT msg reason is unknown, here is some code which can be used to research it
// *remember, that here are more than one window, and any of them can produce 'WM_QUIT'
#if 1
	if (msg.message == WM_QUIT)
	{
		int exit_code;
		HWND hwnd;
extern HWND wnd_console_hwnd;
extern HWND wnd_volume_hwnd;

		hwnd = msg.hwnd;
		exit_code = msg.wParam;
		Error_Log_Printf ("WinMain () :  WM_QUIT code is %08x\n", exit_code);
		if (! hwnd)
// normally is it, when Windows is shutting down
		{
		}
		else if (hwnd == hwnd_icon)
			Error_Log_Printf ("window is of tray icon\n");
		else if (hwnd == wnd_console_hwnd)
			Error_Log_Printf ("window is of console\n");
		else if (hwnd == wnd_volume_hwnd)
			Error_Log_Printf ("window is of volume\n");
		else
			Error_Log_Printf ("window handle %08x is unknown of which window\n", hwnd);
	}
#endif

	B_result = SetEvent (event__thread_exit_request);
	if (! B_result)
	{
//		ErrorReport ("SetEvent () for the thread to exit has failed");
		goto finish;
	}
loop_wait_thread:
	B_result = GetExitCodeThread (h_thread, &D_value);
	if (B_result)
	{
		if (D_value == STILL_ACTIVE)
		{
			Sleep (1);
			goto loop_wait_thread;
		}
	}

// == avoid of so much labels; to do that, have to make an appropriate conditions for everything below ==

finish:
	Measure_Quit ();
	if (h_thread)
		B_result = CloseHandle (h_thread);
	if (event__thread_exit_request)
		B_result = CloseHandle (event__thread_exit_request);

// can't set a condition here, because 'TrayIcon_Init ()' is requested from a few places; so the subroutine will have to handle the condition itself
//	r = TrayIcon_Close ();
	TrayIcon_Close ();

	if (tray_icon_menu)
		B_result = DestroyMenu (tray_icon_menu);

//destroy_window:
// read "Destroying a Window" to know what this function does
// "0xC0000008: Invalid Handle" if try to 'CloseHandle ()' with a HWND; before and after 'DestroyWindow ()' too
// 'IsWindow ()' returns 1 before 'DestroyWindow ()', and 0 after it
// 'DefWindowProc ()' does request it on 'WM_CLOSE', so (almost) can't do it here
// (I dislike it :  creation goes here, destruction goes in 'WndProc ()' - it gives asymmetrical code :/)
//	B_result = IsWindow (hwnd_icon);
//	B_result = DestroyWindow (hwnd_icon);

// a condition isn't mandatory
	WndVolume_OffscreenBitmap_Free ();
// a condition isn't mandatory
	WndVolume_Quit ();

// does not need a condition
	WndConsole_Quit ();

// +++ dll +++
//quit_dll:
// a condition isn't mandatory
	DllHooks_Quit ();
//quit_port_dll:
// a condition isn't mandatory
	DllHooks_Port_Quit ();
// --- dll ---

//finish:
	Hotkeys_Quit ();
	Cvars_Quit ();
	B_result = CloseHandle (h_winrestools_process_global_mutex);
	Assert(B_result);

	return 0;
}

#define POPUP_ANTI_STAY_HACK 1
#define IDT_TIMER1 1

// 'WM_SYSTRAY_ICON' message
LRESULT CALLBACK WndProc_TrayIcon (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	BOOL B_result;
	int pos_x;
	int pos_y;
	POINT point;

#if RESEARCH_WND_MESSAGES
	MsgRecord_Msg (msg);
#endif

	switch (msg)
	{
// *older than v 5.0
	case WM_RBUTTONDOWN:
// *v 5.0
	case WM_CONTEXTMENU:
		B_result = GetCursorPos (&point);
//		pos_x = LOWORD(lparam);
//		pos_y = HIWORD(lparam);
//		pos_x = 100;
//		pos_y = 100;
		pos_x = point.x;
		pos_y = point.y;
#if POPUP_ANTI_STAY_HACK
		SetForegroundWindow (hwnd);
#endif
//		TrackPopupMenu (hSubMenu, TPM_RIGHTBUTTON, pt.x,pt.y, 0, hDlg, NULL);
		B_result = TrackPopupMenuEx
			(
				tray_icon_menu,
				TPM_LEFTALIGN | TPM_LEFTBUTTON,
				pos_x,
				pos_y,
				hwnd,
				NULL
			);
#if POPUP_ANTI_STAY_HACK
		PostMessage (hwnd, WM_NULL, 0, 0);
#endif
		break;

// nope, no any serious messages goes to WM_SYSTRAY_ICON
//	case TTM_SETDELAYTIME:
//		::SendMessage (0, TTM_SETDELAYTIME, TTDT_AUTOPOP, 20000);
//		break;

// is also generated when pointing at the icon by keyboard, and pressing Enter
	case WM_LBUTTONDBLCLK:
		WndConsole_Show ();
		break;
	}

	return 0;
}

typedef WINUSERAPI HWND WINAPI GetShellWindow_t (void);
// not declared anywhere
typedef WINUSERAPI HWND WINAPI GetTaskmanWindow_t (void);

// notify icon 'WndProc ()'
//LRESULT APIENTRY WndProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
LRESULT CALLBACK WndProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	LRESULT lresult;
//	BOOL B_result;
	int id;

#if RESEARCH_WND_MESSAGES
//	MsgRecord_Msg (msg);
#endif

#if 0
	if (hwnd != hwnd_info_tray_icon)
// must not happen
		hwnd = hwnd;
#endif
// only sound :/
//	assert(hwnd == hwnd_info_tray_icon);

	switch (msg)
	{
	case WM_CREATE:
// trying to make tooltip displaying longer; and transparent, if possible
// these do send msg to the windows, and not to their tooltips :/
#if 0
		{
		HWND phwnd;
		HWND dhwnd;
		HWND thwnd;
		HWND shwnd;
		GetShellWindow_t* GetShellWindow_ptr;
		GetTaskmanWindow_t* GetTaskmanWindow_ptr;
// does not works on systray icon tooltip
		::SendMessage (hwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, 20000);
		if (! gh_user32)
			goto no_functions;
//		*(FARPROC*)&GetShellWindow_ptr = GetProcAddress (gh_shell32, "GetShellWindow");
//		*(FARPROC*)&GetTaskmanWindow_ptr = GetProcAddress (gh_shell32, "GetTaskmanWindow");
//		*(FARPROC*)&GetShellWindow_ptr = GetProcAddress (gh_kernel32, "GetShellWindow");
//		*(FARPROC*)&GetTaskmanWindow_ptr = GetProcAddress (gh_kernel32, "GetTaskmanWindow");
		*(FARPROC*)&GetShellWindow_ptr = GetProcAddress (gh_user32, "GetShellWindow");
		*(FARPROC*)&GetTaskmanWindow_ptr = GetProcAddress (gh_user32, "GetTaskmanWindow");
		thwnd = GetTaskmanWindow_ptr ();
		shwnd = GetShellWindow_ptr ();
// does not give anything
		::SendMessage (thwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, 1000);
// does not give anything
		::SendMessage (shwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, 1000);
no_functions:
// 0
		phwnd = GetParent (hwnd);
		dhwnd = GetDesktopWindow ();
//		GetWindow ();
//		GetSystemWindows ();
// also not changes systray tooltip; and not affects anything
//		::SendMessage (dhwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, 20000);
		::SendMessage (dhwnd, TTM_SETDELAYTIME, TTDT_AUTOPOP, 1000);
		}
#endif
		break;

	case WM_COMMAND:
		id = LOWORD(wparam);
		switch (id)
		{
		case ICON_MENU_ID__QUIT:
			PostMessage (hwnd, WM_CLOSE, 0, 0);
			break;
		case ICON_MENU_ID__CONSOLE:
			WndConsole_Show ();
			break;
		}
		return 0;

	case WM_SYSCOMMAND:
//		return 0;
		break;

	case WM_CLOSE:
// by "Win32 Programmer's Reference", request of 'DestroyWindow ()' goes here
// 'DefWindowProc ()' requests it on 'WM_CLOSE' message (tested: 'IsWindow ()' after 'DefWindowProc ()' returns 0)
		break;

	case WM_DESTROY:
// put WM_QUIT
		PostQuitMessage (0);
// test
//		PostQuitMessage (0x12345678);
		return 0;

// shouldn't occur
	case WM_QUIT:
//		hwnd = hwnd;
		Assert(0);
		break;

	case WM_SYSTRAY_ICON:
//		if (GetAsyncKeyState (MK_LBUTTON) < 0)
// **atm I am not sure about where to get lparam and wparam for that
		lresult = WndProc_TrayIcon (hwnd, lparam, 0, 0);

		return 0;

	case WM_HOTKEY:
		hot_keys->OnHotKey (wparam);
		if (hotkey_exit)
// put WM_QUIT
// wrong
//			PostQuitMessage (0);
			DestroyWindow (hwnd);
		break;

#if USE_WNDPROC_MESSAGES
// no, now will be hook used instead of this
// this message is received by every window; and only this one is received at resolution change time
	case WM_DISPLAYCHANGE:
		if (g_refreshlock)
		{
			bool exit_req;
			bool is_screen_changed = 0;

			exit_req = ! Screen_OnDisplayChange (LOWORD(lparam), HIWORD(lparam), wparam, &is_screen_changed);
			if (exit_req)
			{
// wrong
//				PostQuitMessage (0);
				DestroyWindow (hwnd);
				break;
			}
#if REFRESHLOCK_CHANGE_DELAYED
			UINT ui_result;

			if (is_screen_changed)
			{
// *like in "RefreshLock 2.21", but there subroutine ptr also is given
//				ui_result = SetTimer (hwnd, IDT_TIMER1, 50, 0);
// *with 50ms "Descent 3" bugs at level load a bit; and if rise our priority, then bugs very often
// *with 0ms bugs almost always
// *with 100ms, and rised priority bugs at ~20% of times
// *if we have lower priority, then never bugs (with 50ms timer), because of additional (unstable length) big delay
				ui_result = SetTimer (hwnd, IDT_TIMER1, refreshlock_delay, 0);
				if (! ui_result)
					Error ("SetTimer () failed");
			}
#endif
		}
		break;

	case WM_TIMER:
#if REFRESHLOCK_CHANGE_DELAYED
		BOOL B_reult;
		B_reult = KillTimer (hwnd, IDT_TIMER1);
		Screen_OnTimer ();
#endif
		break;
#endif

	case WM_DISPLAYCHANGE:
		TrayIcon_ResolutionChanged (hwnd);
		break;

// does not exist even in MSVC 2005
// and can't exist :  it is registered by IE component at Explorer start
#if 0
	case WM_TASKBARCREATED:
// let it to free an allocated objects first
		TrayIcon_Close ();
// then reinitialize anew
//		r = TrayIcon_Init (hwnd);
		TrayIcon_Init (hwnd);
		break;
#endif

	default:
		if (msg == WM_TASKBARCREATED)
		{
			bool r;
//			uint i;
			bool icon_add_failure;

// let it to free an allocated objects first
			TrayIcon_Close ();
// then reinitialize anew
			r = TrayIcon_Init (hwnd, &icon_add_failure);
//			i = TrayIcon_Init (hwnd, &icon_add_failure);
			if (! r)
//			if (! i)
			{
				ErrorReport ("tray icon initialization at WM_TASKBARCREATED has failed");
				PostQuitMessage (0);
			}
//			else if (i == 1)
			else if (icon_add_failure)
// this case deserves a warning
			{
			}
		}
		break;
	}

//	B_result = IsWindow (hwnd);
//	return CallWindowProc (WndProc_Org, hwnd, msg, wparam, lparam);
	return DefWindowProc (hwnd, msg, wparam, lparam);
}

DWORD WINAPI RevisingThread (VOID*)
{
//	BOOL B_result;
	DWORD D_result;

// flush
	Measure_GetValues ();
//	TrayIcon_Update_ThreeGraphLines (hwnd_info_tray_icon, "updating", 0x0000, 0x0000, 0x0000);
	TrayIcon_Update_GraphLines (hwnd_info_tray_icon, "updating", 0x0000, 0x0000, 0x0000, 0x0000, 0x0000);
// give some time to get cpu usage
	Sleep (1);

loop:
//	TrayIcon_Update_ThreeGraphLines (hwnd_info_tray_icon, "updating", 0xc000, 0x8000, 0x4000);
	Measure_GetValues ();

	Measure_OutputValues ();

	D_result = WaitForSingleObject (event__thread_exit_request, revise_wait_ms);
//	if (D_result == 0)
	if (D_result == WAIT_OBJECT_0)
		return 0;
	if (D_result != WAIT_TIMEOUT)
	{
		ErrorReport ("WaitForSingleObject () error, return result %u", D_result);
// let the message loop to make a turn, and find out, that we have exited
// (*no thread id atm)
//		PostThreadMessage (thread_id, WM_NULL, 0, 0);
		return 0;
	}

	goto loop;
}

