// by Alexander Ilyin
// receiving data from sensors

// for some functions
#define _WIN32_WINNT 0x0501
//#define WINVER 0x0501

#include "measure.h"
#include <windows.h>
#include "fix.h"
#include "main.h"
#include "error.h"
#include "trayicon.h"
#include <stdio.h>


// bad, not included in MSVC 6.0 SP 6
// for MSVC 6.0
#if (_MSC_VER < 1300)
typedef BOOL WINAPI GetSystemTimes_t
(
	LPFILETIME lpIdleTime,
	LPFILETIME lpKernelTime,
	LPFILETIME lpUserTime
);

GetSystemTimes_t* GetSystemTimes = 0;
#endif

measure_value_t measure_values[GRAPH_LINES_NUM_MAX];
// + config +
// value for the low pass filter
// 1/10 of course nice, but that needs much faster updates than 100ms
//fix filter_part = F1_0 / 10;
// 1/4 for 100ms ok
fix filter_part = F1_0 / 4;
// speed limit
fix filter_speed_max = F1_0;
// *there atm is 'graph_lines_num'
//uint measure_lines_num = 3;
measure_line_t measure_lines[GRAPH_LINES_NUM_MAX];
// - config -
char measure_tooltip[512] = {0};


void Measure_Init ()
{
#if (_MSC_VER < 1300)
	if (gh_kernel32)
		*(FARPROC*)&GetSystemTimes = GetProcAddress (gh_kernel32, "GetSystemTimes");
#endif
}

void Measure_Quit ()
{
}

// ... maybe no
#if 0
void Measure_InitRanges ()
{
}
#endif

void Fix_Limit_0_1 (fix* value)
{
	if (*value < 0)
		*value = 0;
	if (*value > F1_0)
		*value = F1_0;
}

void Line_Filter (fix& line, fix& line_old)
{
	fix filter_part_remainder;

// + low pass filter +
	filter_part_remainder = F1_0 - filter_part;
	line = fixmul(line, filter_part);
	line_old = fixmul(line_old, filter_part_remainder);
	line += line_old;
	line_old = line;
// - low pass filter -
// not implemented yet
	filter_speed_max;
}

// *should be replaced with 'measure_values'
fix line_vals[GRAPH_LINES_NUM_MAX];

// should produce 'measure_values'
void Measure_GetValues ()
{
	BOOL B_r;
	SYSTEM_POWER_STATUS system_power_status;
	MEMORYSTATUS memorystatus;
	uint percent_bat;
	uint64 time_idle;
	uint64 time_kernel;
	uint64 time_user;
	static uint64 time_idle_old;
	static uint64 time_kernel_old;
	static uint64 time_user_old;
	bool get_system_times__successful = 0;
//	static char tooltip[512];
	fix cpu_usage;
	fix mem_phys;
	fix mem_phys_above_75;
	fix battery_energy;
	uint percent_cpu_usage;
	uint percent_mem_phys;
//	uint percent_mem_phys_above_75;
#if 0
	fix line0;
	fix line1;
	fix line2;
	fix line3;
	fix line4;
	static fix line0_old = 0;
	static fix line1_old = 0;
	static fix line2_old = 0;
	static fix line3_old = 0;
	int line0_percent;
	int line1_percent;
	int line2_percent;
	int line3_percent;
#endif
	fix* line_val;
	static fix line_vals_old[GRAPH_LINES_NUM_MAX] = {0};
//	static fix line_val_old = 0;
//	uint line_percent[GRAPH_LINES_NUM_MAX];

// +++ get fix values +++
// not in use atm
// + get system status values +
	B_r = GetSystemPowerStatus (&system_power_status);
	if (B_r)
	{
// don't simply use this percentage; instead, convert it to fix (means will be converted twice), so that for it would also be applied a filter
//		battery_energy = INT_TO_FIX(system_power_status.BatteryLifePercent);
//		battery_energy /= 100;
// though why not; it doesn't need a filter
// *is 0xff (-1) if no battery (I don't mean to define battery presence by that)
		percent_bat = system_power_status.BatteryLifePercent;
	}
	else
		percent_bat = 0;

	memorystatus.dwLength = sizeof(memorystatus);
	GlobalMemoryStatus (&memorystatus);

//	GetThreadTimes;
// thx Ejor for pointing at that function
#if (_MSC_VER < 1300)
	if (GetSystemTimes)
#endif
	{
		B_r = GetSystemTimes ((FILETIME*)&time_idle, (FILETIME*)&time_kernel, (FILETIME*)&time_user);
		get_system_times__successful = !! B_r;
	}

// possibly some more
//	CallNtPowerInformation
//	GetSystemFirmwareTable
// hoho, "Requires Windows Server 2003 SP1."
//	EnumSystemFirmwareTables
#if 0
	UINT ui;
	byte test_buf[1024];
// *not sure
#if (_MSC_VER < 1300)
	typedef UINT WINAPI EnumSystemFirmwareTables_t (DWORD FirmwareTableProviderSignature, PVOID pFirmwareTableBuffer, DWORD BufferSize);
	EnumSystemFirmwareTables_t* EnumSystemFirmwareTables;
	if (gh_kernel32)
		*(FARPROC*)&EnumSystemFirmwareTables = GetProcAddress (gh_kernel32, "EnumSystemFirmwareTables");
#endif
	ui = EnumSystemFirmwareTables ('ACPI', test_buf, sizeof(test_buf));
#endif
// - get system status values -

//// calculate line heights
//// calculate percentage values
	if (get_system_times__successful)
	{
// delta times
		uint64 time_idle_d;
		uint64 time_kernel_d;
		uint64 time_user_d;
		uint64 time_system_d;
		uint64 cpu_usage__fix;

		time_idle_d = time_idle - time_idle_old;
		time_kernel_d = time_kernel - time_kernel_old;
		time_user_d = time_user - time_user_old;

		time_idle_old = time_idle;
		time_kernel_old = time_kernel;
		time_user_old = time_user;

		time_system_d = time_kernel_d + time_user_d;
		cpu_usage__fix = time_system_d - time_idle_d;
		cpu_usage__fix *= F1_0;
		if (time_system_d)
			cpu_usage__fix /= time_system_d;
		else
//			cpu_usage__fix = F0_5;
			cpu_usage__fix = 0;
//		line1 = (ulong)cpu_usage__fix;
		cpu_usage = (ulong)cpu_usage__fix;
	}
	else
//	{
//		line1 = 0;
		cpu_usage = 0;
//	}

//	line0 = (ulong)((uint64)memorystatus.dwAvailPhys * F1_0 / memorystatus.dwTotalPhys);
//	line0 = F1_0 - line0;
	mem_phys = (ulong)((uint64)memorystatus.dwAvailPhys * F1_0 / memorystatus.dwTotalPhys);
	mem_phys = F1_0 - mem_phys;
// 50-100% range
//	line2 = (ulong)((uint64)memorystatus.dwAvailPhys * F1_0 * 2 / memorystatus.dwTotalPhys);
// 75-100% range
//	line2 = (ulong)((uint64)memorystatus.dwAvailPhys * F1_0 * 4 / memorystatus.dwTotalPhys);
//	line2 = F1_0 - line2;
//	mem_phys_above_75 = (ulong)((uint64)memorystatus.dwAvailPhys * F1_0 * 4 / memorystatus.dwTotalPhys);
// --- get fix values ---

#if (_MSC_VER < 1300)
	if (GetSystemTimes)
#endif
		B_r = GetSystemTimes ((FILETIME*)&time_idle_old, (FILETIME*)&time_kernel_old, (FILETIME*)&time_user_old);

	mem_phys_above_75 = F1_0 - mem_phys;
	mem_phys_above_75 *= 4;
	mem_phys_above_75 = F1_0 - mem_phys_above_75;

// == calculate percentages ==
	percent_cpu_usage = FIX_TO_INT(cpu_usage * 100);
	percent_mem_phys = FIX_TO_INT(mem_phys * 100);
//	percent_mem_phys_above_75 = FIX_TO_INT(mem_phys_above_75 * 100);
// == calculate by percentages (backward) ==
	battery_energy = INT_TO_FIX(percent_bat);
	battery_energy /= 100;

	Assert(graph_lines_num == 3 || graph_lines_num == 5);
// don't calculate here; just use
	FORI0(graph_lines_num)
	{
		line_val = &line_vals[i];
		switch (graph_line_functions[i])
		{
		case TRAYICON_LINE_FUNC__NONE:
			*line_val = 0;
			break;
		case TRAYICON_LINE_FUNC__CPU_USAGE:
			*line_val = cpu_usage;
			break;
		case TRAYICON_LINE_FUNC__MEM_PHYS:
			*line_val = mem_phys;
			break;
		case TRAYICON_LINE_FUNC__MEM_PHYS_ABOVE_75:
			*line_val = mem_phys_above_75;
			break;
		case TRAYICON_LINE_FUNC__BATTERY_ENERGY_PERCENT:
//// here is backward :  calculate fix by percentage
//// no, don't do so simple; instead, convert it twice, so that for it would also be applied a filter
//			line_percent[i] = system_power_status.BatteryLifePercent;
//			*line_val = INT_TO_FIX(system_power_status.BatteryLifePercent);
//			*line_val /= 100;
			*line_val = battery_energy;
//			goto;
//			continue;
			break;
		default:
			Error ("RevisingThread () :  wrong line function %u", graph_line_functions[i]);
		}

// actually it is necessary only for cpu usage line, but I will leave it meanwhile
		Line_Filter (*line_val, line_vals_old[i]);

// apply limits, for further calculations
		Fix_Limit_0_1 (line_val);

//		line_percent[i] = *line_val * 100 / F1_0;
	}

#if 0
	Line_Filter (line0, line0_old);
	Line_Filter (line1, line1_old);
	Line_Filter (line2, line2_old);
//	Line_Filter (line3, line3_old);

// apply limits, for further calculations
	Fix_Limit_0_1 (&line0);
	Fix_Limit_0_1 (&line1);
	Fix_Limit_0_1 (&line2);
//	Fix_Limit_0_1 (&line3);
	line3 = 0;
	line4 = 0;

// calculate percentages
	line0_percent = line0 * 100 / F1_0;
	line1_percent = line1 * 100 / F1_0;
	line2_percent = line2 * 100 / F1_0;
	line3_percent = system_power_status.BatteryLifePercent;
#endif

	if (system_power_status.BatteryFlag < 128)
		_snprintf (measure_tooltip, sizeof(measure_tooltip) - 1, "%02d%% mem, %02d%% cpu, %02d%% bat", percent_mem_phys, percent_cpu_usage, percent_bat);
	else
		_snprintf (measure_tooltip, sizeof(measure_tooltip) - 1, "%02d%% mem, %02d%% cpu", percent_mem_phys, percent_cpu_usage);
}

// should take 'measure_values', convert them, then output
void Measure_OutputValues ()
{
//	TrayIcon_Update_ThreeGraphLines (hwnd_info_tray_icon, tooltip, line0, line1, line2);
	TrayIcon_Update_GraphLines (hwnd_info_tray_icon, measure_tooltip, line_vals[0], line_vals[1], line_vals[2], line_vals[3], line_vals[4]);
}

