// by Alexander Ilyin

#include "notify.h"
#include "trayicon.h"
#include "wnd_console.h"


void Notify_SetLevel (uint lvl)
{
	static uint mutex = 0;

// need a mutex anyway !
#if 0
// no need a mutex :)
	while (tray_icon_notification_level < lvl)
		__asm inc tray_icon_notification_level
#endif

wait_mutex:
	__asm inc mutex
	if (mutex != 1)
// some conflict
	{
		__asm dec mutex
		Sleep (1);
		goto wait_mutex;
	}

	if (! WndConsole_IsActive ())
	{
		tray_icon_notification_level = lvl;
	}

	__asm dec mutex
}

// red
void Notify_Errorf (const char* format, ...)
{
	va_list argptr;

	Notify_SetLevel (3);
	va_start (argptr, format);
	WndConsole_PrintVA (format, argptr);
	va_end (argptr);
}

// yellow
void Notify_Warnf (const char* format, ...)
{
	va_list argptr;

	Notify_SetLevel (2);
	va_start (argptr, format);
	WndConsole_PrintVA (format, argptr);
	va_end (argptr);
}

// green; when have to attract a user, but it isn't a warning or an error
void Notify_Infof (const char* format, ...)
{
	va_list argptr;

	Notify_SetLevel (1);
	va_start (argptr, format);
	WndConsole_PrintVA (format, argptr);
	va_end (argptr);
}

// *does not notify, but for simmetry, it also is placed here
void Notify_Printf (const char* format, ...)
{
	va_list argptr;

	va_start (argptr, format);
	WndConsole_PrintVA (format, argptr);
	va_end (argptr);
}

