#pragma once

// by Alexander Ilyin

#include <windows.h>
#include "fix.h"
#include "types.h"
#include "macros.h"


// +++ config +++
extern int graph_lines_num;
extern ulong graph_background_color;
extern ulong graph_line_color_0;
extern ulong graph_line_color_1;
extern ulong graph_line_color_2;
extern ulong graph_line_color_3;
extern ulong graph_line_color_4;
extern ulong graph_line_functions[5];
extern bool trayicon_patch;
// --- config ---

extern uint tray_icon_notification_level;

// *must not be here
// *not +1; they are in use
//#define WM_SYSTRAY_ICON (WM_USER + 1)
#define WM_SYSTRAY_ICON (WM_USER + 201)

#undef TRAYICON_LINE_FUNC
#define TRAYICON_LINE_FUNC(_name_) TRAYICON_LINE_FUNC__##_name_
enum
{
#include "trayicon_line_funcs_enum.h"
	TRAYICON_LINE_FUNCS_NUM
};
#undef TRAYICON_LINE_FUNC
#define TRAYICON_LINE_FUNC(_name_) #_name_
const char* const trayicon_line_funcs_names[] =
{
#include "trayicon_line_funcs_enum.h"
};
const uint trayicon_line_funcs_num = NUMOF(trayicon_line_funcs_names);


//bool TrayIcon_Init (HWND hwnd);
//uint TrayIcon_Init (HWND hwnd);
bool TrayIcon_Init (HWND hwnd, bool* icon_add_failure = 0);
//bool TrayIcon_Close ();
void TrayIcon_Close ();
void TrayIcon_ResolutionChanged (HWND hwnd);
//bool TrayIcon_LineSetFunction (uint line_ix, string& func_name);
bool TrayIcon_LineSetFunction (uint line_ix, const char* func_name);
//bool TrayIcon_Update_ThreeGraphLines (HWND hwnd, char* tooltip, fix line0, fix line1, fix line2);
bool TrayIcon_Update_GraphLines (HWND hwnd, char* tooltip, fix line0, fix line1, fix line2, fix line3, fix line4);

