// by Alexander Ilyin
// Windows does not provide a handle to the trayicon wnd, so I could customize it; options :
// 1) silently cry
// 2) take myself in the hands; swear the Windows with a bad word; get the necessary handle by an other way
// both windows (tool bar and the icon) handle getting is  by (Irek) Ireneusz Zielinski src of 'CTrayIconPosition'

#include "trayicon_utils.h"
#include <tchar.h>
#include <commctrl.h>
#include "error.h"
#include "macros.h"


// + wnd search +
static HWND hwnd_callback_return = 0;
static const char* wnd_classname = 0;
// - wnd search -


BOOL CALLBACK TrayIconUtils_EnumChildProc (HWND hwnd, LPARAM lparam)
{
	int i_r;
	TCHAR class_name[256];

	i_r = GetClassName (hwnd, class_name, sizeof(class_name));
	if (! i_r)
// continue search
		return 1;
//	i_r = _tcscmp (class_name, _T("TrayNotifyWnd"));
	i_r = _tcscmp (class_name, wnd_classname);
	if (i_r)
// continue search
		return 1;
//	Assert(lparam);
//	*(HWND*)lparam = hwnd;
	hwnd_callback_return = hwnd;
// don't continue the search
	return 0;
}

//bool TrayIconUtils_GetHandle (HWND& hwnd, const char* name)
bool TrayIconUtils_GetHandle_ToolBar (HWND& hwnd)
{
	BOOL B_r;
// *perhaps not notify, but just shell tray
//	HWND hwnd_shell_tray_notify;
// the whole tray below
	HWND hwnd_shell_tray;
// notification area
	HWND hwnd_tray_notify;
// a part with an icons, to the left side from the clock, as I understand
	HWND hwnd_tool_bar;

	hwnd_shell_tray = 0;
	hwnd_tray_notify = 0;
	hwnd_tool_bar = 0;

// test :  both are failing
	hwnd_tray_notify = FindWindow(_T("TrayNotifyWnd"), 0);
	hwnd_tool_bar = FindWindow(_T("ToolbarWindow32"), 0);

	hwnd_shell_tray = FindWindow(_T("Shell_TrayWnd"), 0);
	if (! hwnd_shell_tray)
		return 0;

	wnd_classname = _T("TrayNotifyWnd");
	hwnd_callback_return = 0;
//	B_r = EnumChildWindows (hwnd_shell_tray, TrayIconUtils_EnumChildProc_TrayNotify, (LPARAM)&hwnd_tray_notify);
	B_r = EnumChildWindows (hwnd_shell_tray, TrayIconUtils_EnumChildProc, 0);
// *cannot check by return result; in case of success, it will return what returns 'TrayIconUtils_EnumChildProc ()', means 0
//	if (! B_r)
//		return 0;
	if (! hwnd_callback_return)
		return 0;
	if (! IsWindow (hwnd_callback_return))
		return 0;
	hwnd_tray_notify = hwnd_callback_return;

	wnd_classname = _T("ToolbarWindow32");
	hwnd_callback_return = 0;
//	B_r = EnumChildWindows (hwnd_tray_notify, TrayIconUtils_EnumChildProc_ToolBarInTray, (LPARAM)&hwnd_tool_bar);
	B_r = EnumChildWindows (hwnd_tray_notify, TrayIconUtils_EnumChildProc, 0);
//	if (! B_r)
//		return 0;
	if (! hwnd_callback_return)
		return 0;
	if (! IsWindow (hwnd_callback_return))
		return 0;
	hwnd_tool_bar = hwnd_callback_return;

//	return hwnd_tool_bar;
//	return hwnd_tray_notify;
//	return hwnd_shell_tray;
	hwnd = hwnd_tool_bar;

	return 1;
}

// ha, buttons seems don't have a window handle
bool TrayIconUtils_GetHandle_Icon (HWND& hwnd_icon, HWND hwnd_tool_bar, HWND hwnd_owner, uint icon_id)
{
//	bool r;
	bool result;
	BOOL B_r;
	LRESULT L_r;
	DWORD tray_tool_bar_process_id;
	HANDLE hprocess;
	uint buttons_count;
	void* data;
	uint i;

	result = 0;
	hprocess = 0;
	data = 0;
	Assert(hwnd_tool_bar);
	tray_tool_bar_process_id = -1;
	GetWindowThreadProcessId (hwnd_tool_bar, &tray_tool_bar_process_id);
	if (tray_tool_bar_process_id <= 0)
		return 0;

	hprocess = OpenProcess (PROCESS_ALL_ACCESS, 0, tray_tool_bar_process_id);
	if (! hprocess)
		return 0;

	buttons_count = SendMessage (hwnd_tool_bar, TB_BUTTONCOUNT, 0, 0);
	if (! buttons_count)
//		return 0;
		goto finish;
// something sane
	Assert(buttons_count < 100);

// We want to get data from another process - it's not possible to just send messages like TB_GETBUTTON with a localy allocated buffer for return data.
// Pointer to localy allocated data has no usefull meaning in a context of another process (since Win95) - so we need to allocate some memory inside Tray process.
// We allocate sizeof(TBBUTTON) bytes of memory - because TBBUTTON is the biggest structure we will fetch.
// But this buffer will be also used to get smaller pieces of data like RECT structures.
	data = VirtualAllocEx (hprocess, 0, sizeof(TBBUTTON), MEM_COMMIT, PAGE_READWRITE);
	if (! data)
		goto finish;

//	FORI0(buttons_count)
	for (i = 0; i < buttons_count; i++)
	{
		DWORD bytes_read;
		TBBUTTON button_data;
//		DWORD extra_data[2] = {0, 0};
		ulong extra_data[2];
		HWND hwnd_of_icon_owner;
		uint id;

// first let's read TBUTTON information about each button in a task bar of tray
		L_r = SendMessage (hwnd_tool_bar, TB_GETBUTTON, i, (LPARAM)data);
		if (! L_r)
			continue;
		bytes_read = -1;
		B_r = ReadProcessMemory (hprocess, data, &button_data, sizeof(TBBUTTON), &bytes_read);
		if (bytes_read < sizeof(TBBUTTON))
			continue;
		if (! button_data.dwData)
			continue;

// now let's read extra data associated with each button: there will be a HWND of the window that created an icon and icon ID
		ReadProcessMemory (hprocess, (LPVOID)button_data.dwData, extra_data, sizeof(extra_data), &bytes_read);
		if (bytes_read < sizeof(extra_data))
			continue;
		Assert(bytes_read == sizeof(extra_data));

		hwnd_of_icon_owner = (HWND)extra_data[0];
		id = extra_data[1];

		if (hwnd_of_icon_owner != hwnd_owner)
			continue;
		if (id != icon_id)
			continue;

//we found our icon - in WinXP it could be hidden - let's check it:
//		if (button_data.fsState & TBSTATE_HIDDEN)
//			break;

// hmmm
		hwnd_icon = 0;
		result = 1;
		break;
	}

finish:
	if (data)
	{
		Assert(hprocess);
		VirtualFreeEx (hprocess, data, 0, MEM_RELEASE);
	}
	if (hprocess)
		CloseHandle (hprocess);

	return result;
}

void TrayIconUtils_Patch (HWND hwnd_owner, uint icon_id)
{
	bool r;
	HWND hwnd_tool_bar;
//	HWND hwnd_icon;

	r = TrayIconUtils_GetHandle_ToolBar (hwnd_tool_bar);
	if (! r)
		return;
#if 0
	r = TrayIconUtils_GetHandle_Icon (hwnd_icon, hwnd_tool_bar, hwnd_owner, icon_id);
	if (! r)
		return;
#endif
	;
}

