// hooks, which supported by a Windows OS itself
// *not in use
// must hook, to have ability to remove the message from the queue

#include "winhook.h"
#include <windows.h>
#include "main.h"
#include "screen.h"
#include "error.h"


LRESULT CALLBACK WinHook_Hook_Messages (int hook_code, WPARAM w_param, LPARAM l_param);
HHOOK win_msg_hook = 0;


void WinHook_Init ()
{
	DWORD thread_id;
	HMODULE h_module;

	thread_id = GetCurrentThreadId ();
	h_module = GetModuleHandle (0);
// WH_CALLWNDPROC is before wnd proc request, WH_CALLWNDPROCRET is after;
// WH_GETMESSAGE hooks message post by one description, although sounds different, and hooks 'GetMessage ()' by another.
// *"RefreshLock 2.21" hooks WH_GETMESSAGE
	win_msg_hook = SetWindowsHookEx (WH_GETMESSAGE, WinHook_Hook_Messages, 0, thread_id);
//	win_msg_hook = SetWindowsHookEx (WH_GETMESSAGE, WinHook_Hook_Messages, h_module, 0);

// Microsoft example
#if 0
HOOKPROC hkprcSysMsg; 
static HINSTANCE hinstDLL; 
static HHOOK hhookSysMsg; 
 
hinstDLL = LoadLibrary((LPCTSTR) "c:\\windows\\sysmsg.dll"); 
hkprcSysMsg = (HOOKPROC)GetProcAddress(hinstDLL, "SysMessageProc"); 
hhookSysMsg = SetWindowsHookEx(WH_SYSMSGFILTER,hkprcSysMsg,hinstDLL,0);
#endif
}

//void WinHook_OnWmDisplayChange (CWPSTRUCT* cwpstruct)
void WinHook_OnWmDisplayChange (MSG* msg)
{
//	bool exit_req;
	bool is_screen_changed = 0;

	if (! g_config_settings.refreshlock)
		return;

	is_screen_changed = is_screen_changed;
#if 0
	exit_req = ! Screen_OnDisplayChange (LOWORD(msg->lParam), HIWORD(msg->lParam), msg->wParam, &is_screen_changed);
	if (exit_req)
		PostQuitMessage (0);
// make message unuseful, if we have dealed with it, so it will appear again later, but because that we have done our request
	if (is_screen_changed)
// 'WM_NULL' description says, that the one may be used exactly for that
#endif
		msg->message = WM_NULL;
}

// 'GetMsgProc ()'
LRESULT CALLBACK WinHook_Hook_Messages (int hook_code, WPARAM w_param, LPARAM l_param)
{
	LRESULT lresult;
//	CWPSTRUCT* cwpstruct;
	MSG* msg;

// this code means previous hooks processed work state, as I understand
	if (hook_code != HC_ACTION)
		goto finish;
//	Assert(w_param);
	Assert(l_param);
//	cwpstruct = (CWPSTRUCT*)l_param;
	msg = (MSG*)l_param;
// 0x007E
	if (msg->message == WM_DISPLAYCHANGE)
		WinHook_OnWmDisplayChange (msg);
finish:
	lresult = CallNextHookEx (win_msg_hook, hook_code, w_param, l_param);
	return lresult;
}

