// reports console

#include "wnd_console.h"
#include "error.h"
#include "vec_str.h"
#include "types.h"
//#include "trayicon.h"
#include "notify.h"


HWND wnd_console_hwnd = 0;
LRESULT CALLBACK WndConsole_WndProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
bool wnd_console_is_shown = 0;
bool wnd_console_initialized = 0;
vec_str_t wnd_console_strings;

#define IDC_EDIT1 2000
HWND hwnd_edit = 0;


// *a request this function (which contains 'RegisterClass ()', 'CreateWindow ()') does not change total memory amount used by the application; and virtual also does not
bool WndConsole_Init (HINSTANCE h_instance)
{
//	BOOL B_result;
	WNDCLASS wc;
	ATOM atom;

	wnd_console_initialized = 0;
	wnd_console_is_shown = 0;
// remove all strings
// ergh, before this function request, there can already be some reports; don't remove them :/
//	wnd_console_strings.clear();

	wc.style = 0;
	wc.lpfnWndProc = WndConsole_WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = h_instance;
//	wc.hIcon = icon;
	wc.hIcon = 0;
	wc.hCursor = 0;
	wc.hbrBackground = 0;
	wc.lpszMenuName = 0;
	wc.lpszClassName = "Win_Resident_Tools_console_class";

	atom = RegisterClass (&wc);
	if (! atom)
		return 0;

	wnd_console_hwnd = CreateWindow
		(
			(char*)atom,
// *it receives only own events; at least atm
			"Windows Resident Tools - own events console",
			WS_OVERLAPPEDWINDOW,
//			WS_OVERLAPPEDWINDOW | WS_HSCROLL | WS_VSCROLL | ES_MULTILINE | ES_AUTOHSCROLL,
//			WS_OVERLAPPEDWINDOW | ES_MULTILINE | ES_AUTOHSCROLL,
// a starting up standard window is a bit too big; it is better to reduce it
			CW_USEDEFAULT,
			CW_USEDEFAULT,
//			CW_USEDEFAULT,
//			CW_USEDEFAULT,
			400,
			200,
			0,
			0,
			h_instance,
			0
		);
	if (! wnd_console_hwnd)
		return 0;

// "You create a rich edit control by using the CreateWindowEx function, specifying the "RichEdit" window class. You must call the LoadLibrary function to ensure that the RICHED32.DLL library is loaded before the rich edit control is created."
// though I don't think I wan't RichEdit; maybe a part of Scintilla is better ...
// I need a coloured strings; that's for what I would need Scintilla or RichEdit
//	hwnd_edit = CreateWindowEx (WS_EX_CLIENTEDGE, "Edit", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | 0X80 | ES_MULTILINE, 0, 4 + 24, 20, 20, wnd_console_hwnd, (HMENU)IDC_EDIT1, h_instance, 0);
//	hwnd_edit = CreateWindowEx (WS_EX_CLIENTEDGE, "Edit", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | 0X80 | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_NOHIDESEL | WS_VSCROLL | WS_HSCROLL, 0, 4 + 24, 20, 20, wnd_console_hwnd, (HMENU)IDC_EDIT1, h_instance, 0);
	hwnd_edit = CreateWindowEx (WS_EX_CLIENTEDGE, "Edit", "", WS_CHILD | WS_VISIBLE | WS_TABSTOP | 0X80 | ES_MULTILINE | ES_AUTOHSCROLL | ES_AUTOVSCROLL | ES_NOHIDESEL | ES_READONLY | WS_VSCROLL | WS_HSCROLL, 0, 4 + 24, 20, 20, wnd_console_hwnd, (HMENU)IDC_EDIT1, h_instance, 0);
//	SendMessage (hwnd_edit, WM_SETFONT, (WPARAM) h_font, TRUE);

//	B_result = DestroyWindow (wnd_console_hwnd);
//	B_result = IsWindow (wnd_console_hwnd);

	wnd_console_initialized = 1;

// test
#if 0
	WndConsole_Print ("test 01");
	WndConsole_Print ("test 02");
	WndConsole_Print ("test 03");
	WndConsole_Print ("test 04");
	WndConsole_Print ("test 05");
	WndConsole_Print ("test 06");
	WndConsole_Print ("test 07");
	WndConsole_Print ("test 08");
	WndConsole_Print ("test 09");
	WndConsole_Print ("test 10");
#endif
	WndConsole_Print ("Console initialized.");

	return 1;
}

void WndConsole_Quit ()
{
	wnd_console_initialized = 0;
}

void WndConsole_Show ()
{
// remove a tray icon notification :  user is looking for a notification reasons right now
//	tray_icon_notification_level = 0;
	Notify_SetLevel (0);
	if (wnd_console_is_shown)
		return;
	ShowWindow (wnd_console_hwnd, SW_SHOW);
	UpdateWindow (wnd_console_hwnd);
}

void WndConsole_Hide ()
{
	if (! wnd_console_is_shown)
		return;
	ShowWindow (wnd_console_hwnd, SW_HIDE);
	UpdateWindow (wnd_console_hwnd);
}

// volume 'WndProc ()'
LRESULT CALLBACK WndConsole_WndProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	BOOL B_r;

// no, the first (at all) going here message is 'WM_GETMINMAXINFO', and at that moment, the 'CreateWindow ()' isn't returned yet
//	Assert(hwnd == wnd_console_hwnd);
	switch (msg)
	{
	case WM_CREATE:
		break;

	case WM_DESTROY:
		break;

	case WM_SIZE:
		RECT rect;
		uint x;
		uint y;
		uint w;
		uint h;
		B_r = GetClientRect (hwnd, &rect);
		if (! B_r)
			break;
		x = rect.left;
		y = rect.top;
		w = rect.right - rect.left;
		h = rect.bottom - rect.top;
// test
//		w -= 2;
//		h -= 2;
// put the edit control on the whole (except header and borders) window size
		B_r = SetWindowPos (hwnd_edit, HWND_NOTOPMOST, x, y, w, h, SWP_NOZORDER | SWP_NOACTIVATE);
// *it is another thing, it is a virtual area for the scroll
//		SendDlgItemMessage (hwnd, IDC_EDIT1, EM_SETRECT, 0, (LPARAM)&rect);
		break;

// *and only if a text indication needs to be done in this way
	case WM_PAINT:
#if 0
		PAINTSTRUCT ps;
		HDC hdc;
//		RECT r;
		hdc = BeginPaint (hwnd, &ps);
//		GetClientRect (hwnd, &r);
//		FillRect (hdc, &r, (HBRUSH)GetStockObject (GRAY_BRUSH));
//		TextOut (hdc, 0, 0, "hello world :)", 14);
		EndPaint (hwnd, &ps);
#endif
		break;

	case WM_CLOSE:
// don't destroy, but hide instead; though I don't think it is proper, but then need additional button, like eMule have, to handle the things properly
// though this window have caption "console", by which is able to distinguish it from the application itself;
// so maybe the hide instead of closing the app - is a proper way
		WndConsole_Hide ();
		return 0;
//		break;

#if 0
	case WM_ERASEBKGND:
		hdc = (HDC)wparam; 
		GetClientRect (hwnd, &rc); 
		SetMapMode(hdc, MM_ANISOTROPIC); 
		SetWindowExtEx(hdc, 100, 100, NULL); 
		SetViewportExtEx(hdc, rc.right, rc.bottom, NULL); 
		FillRect(hdc, &rc, hbrWhite); 
		
		for (i = 0; i < 13; i++)
		{
			x = (i * 40) % 100; 
			y = ((i * 40) / 100) * 20; 
			SetRect(&rc, x, y, x + 20, y + 20); 
			FillRect(hdc, &rc, hbrGray); 
		} 
		return 1L;
#endif

	case WM_SHOWWINDOW:
		wnd_console_is_shown = !! wparam;
		break;

	default:
		break;
	}

	return DefWindowProc (hwnd, msg, wparam, lparam);
}

void WndConsole_Print (const char* str)
{
	static uint mutex = 0;
	string txt;

//	if (! wnd_console_initialized)
//		return;
// mutate 'wnd_console_strings'
// *such simple mutex may switch some strings with places
wait_mutex:
	__asm inc mutex
	if (mutex != 1)
// some conflict
	{
		__asm dec mutex
		Sleep (1);
		goto wait_mutex;
	}

// shouldn't be a senseless size
#define WND_CONSOLE_STRINGS_MAX 1000
	if (wnd_console_strings.size() >= WND_CONSOLE_STRINGS_MAX)
// a linked list perhaps would be faster :)
		wnd_console_strings.erase(wnd_console_strings.begin());
// not supported
//		wnd_console_strings.erase(0);
	Assert(wnd_console_strings.size() <= WND_CONSOLE_STRINGS_MAX);
	wnd_console_strings.push_back(str);

	vec_str_t::iterator it;
	vec_str_t::iterator it_end;
	it = wnd_console_strings.begin();
	it_end = wnd_console_strings.end();
	while (it != it_end)
	{
		txt.append(*it);
		txt.append("\r\n");
		it++;
	}
//	SendMessage (hwnd_edit, WM_SETTEXT, 0, (LPARAM)str);
	SendMessage (hwnd_edit, WM_SETTEXT, 0, (LPARAM)txt.c_str());

	__asm dec mutex
}

void WndConsole_PrintVA (const char* format, va_list arglist)
{
	static char buf[1024];
	static uint mutex = 0;
	string txt;

//	if (! wnd_console_initialized)
//		return;
// mutate 'buf[]'
wait_mutex:
	__asm inc mutex
	if (mutex != 1)
// some conflict
	{
		__asm dec mutex
		Sleep (1);
		goto wait_mutex;
	}

	_vsnprintf (buf, sizeof(buf) - 1, format, arglist);
	buf[sizeof(buf) - 1] = 0;
	WndConsole_Print (buf);

	__asm dec mutex
}

// use this only if don't need any notification on trayicon; otherwise, use some 'Notify_Printf ()'
#if 0
void WndConsole_Printf (const char* format, ...)
{
	va_list argptr;

	va_start (argptr, format);
	WndConsole_PrintVA (format, argptr);
	va_end (argptr);
}
#endif

void WndConsole_Activate (void* param)
{
// reactivate it
	WndConsole_Hide ();
	WndConsole_Show ();
}

bool WndConsole_IsActive ()
{
	return wnd_console_is_shown;
}

