// sound volume short temporary indicator

#include "wnd_volume.h"
#include "error.h"
#include "macros.h"
#include <stdio.h>


HWND wnd_volume_hwnd = 0;
LRESULT CALLBACK WndVolume_WndProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam);
static BOOL (WINAPI* pfnSetLayeredWindowAttributes) (HWND hwnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags) = 0;
bool wnd_volume_is_shown = 0;
// various bitmaps e.t.c.
bool wnd_volume_is_allocated = 0;

// basic value, which should be scaled
// base isn't decimal; values are 0000-ffff
//#define WND_VOLUME_LINE_BASIC_WIDTH 100
#define WND_VOLUME_LINE_BASIC_WIDTH 0x100
#define WND_VOLUME_LINE_BASIC_HEIGHT 20
//#define WND_VOLUME_LINE_BASIC_HEIGHT 10
//#define WND_VOLUME_LINE_BASIC_HEIGHT 8

uint wnd_volume_requested_scale = 0;
uint wnd_volume_scale = 0;
uint wnd_volume_line_width = 0;
uint wnd_volume_line_height = 0;
uint wnd_volume_indent_x = 0;
uint wnd_volume_indent_y = 0;
uint wnd_volume_width = 0;
uint wnd_volume_height = 0;
uint wnd_volume_pos_x = 0;
uint wnd_volume_pos_y = 0;
//HDC wnd_volume_hdc_test = 0;
// device context for drawing into it
HDC wnd_volume_hdc_draw = 0;
// this bitmap should not be visible - it is only for serving for the WM_PAINT message
//HBITMAP wnd_volume_bitmap_test = 0;
// bitmap for drawing into it
HBITMAP wnd_volume_bitmap_draw = 0;
// is in 00000000 (incl.) - 00010000 (excl.) range (I am not defining it; just using what is)
ulong wnd_volume_value = 0;
UINT_PTR wnd_volume_timer = 0;
// init with a weak sense values, to force a user to configure his "config.cfg"
// +++ config +++
bool wnd_volume_show = 0;
uint wnd_volume_timer_elapse_ms = 100;
bool wnd_volume_discoloured = 0;
//uint wnd_volume_opacity = 100;
byte wnd_volume_opacity = 0x10;
// --- config ---

// *support begins only from Windows 2000
#define LWA_ALPHA 2
#define WS_EX_LAYERED 0x00080000


void WndVolume_InitFunctions ()
{
HMODULE h_user32;

// *"user32.dll" must be loaded before, for this way
	h_user32 = GetModuleHandle (TEXT("USER32"));

	if (h_user32)
	{
		*(FARPROC*)&pfnSetLayeredWindowAttributes = GetProcAddress (h_user32, "SetLayeredWindowAttributes");
// too global
//		*(FARPROC*)&pfnBlockInput = GetProcAddress (h_user32, "BlockInput");
	}

//	functions_pointers_initialized = 1;
}

// a window is always capturing a controls; so to avoid that, I will try to draw straightly to the screen;
// but for such way, at very least, have to draw into a bitmap first
bool WndVolume_Init (HINSTANCE h_instance)
{
//	BOOL B_result;
	WNDCLASS wc;
	ATOM atom;

	wnd_volume_is_shown = 0;
	wnd_volume_is_allocated = 0;
// some value
	wnd_volume_value = 0x9000;

	WndVolume_InitFunctions ();

	wc.style = 0;
	wc.lpfnWndProc = WndVolume_WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = h_instance;
//	wc.hIcon = icon;
	wc.hIcon = 0;
	wc.hCursor = 0;
	wc.hbrBackground = 0;
	wc.lpszMenuName = 0;
	wc.lpszClassName = "Win_Resident_Tools_volume_class";

	atom = RegisterClass (&wc);
	if (! atom)
		return 0;

	wnd_volume_hwnd = CreateWindow
		(
			(char*)atom,
			"Windows Resident Tools - volume indicator window",
//			WS_OVERLAPPEDWINDOW,
//			0,
			WS_POPUP,
// 'WS_DISABLED' looks good, but it still isn't the complete transparence
//			WS_POPUP | WS_DISABLED,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			0,
			0,
			h_instance,
			0
		);
	if (! wnd_volume_hwnd)
		return 0;

	return 1;
}

void WndVolume_Quit ()
{
}

// define window sizes and position
// -1 - auto
static void WndVolume_Scale ()
{
	double d;
	int size_x;
	int size_y;
	uint scale;

// don't change sizes, while the window still is in render
	Assert(! wnd_volume_is_allocated);

	scale = wnd_volume_requested_scale;
	size_x = GetSystemMetrics (SM_CXSCREEN);
	size_y = GetSystemMetrics (SM_CYSCREEN);
	if (scale != -1)
	{
		wnd_volume_line_width = WND_VOLUME_LINE_BASIC_WIDTH * scale;
		wnd_volume_line_height = WND_VOLUME_LINE_BASIC_HEIGHT * scale;
		goto define_window_size;
	}
//	d = 0;
	d = size_x;
	d /= WND_VOLUME_LINE_BASIC_WIDTH;
//	d /= 2.0;
// 256 * 4 * 2 :  from 2048xNNNN the scale will become 2
	d /= 4.0;
//	d += 0.5;
	scale = (uint)d;
	if (! scale)
		scale = 1;
	wnd_volume_line_width = WND_VOLUME_LINE_BASIC_WIDTH * scale;
	wnd_volume_line_height = WND_VOLUME_LINE_BASIC_HEIGHT * scale;

define_window_size:
	wnd_volume_scale = scale;
	wnd_volume_indent_x = wnd_volume_line_width / 10;
	wnd_volume_indent_y = wnd_volume_line_height / 2;
	wnd_volume_width = wnd_volume_line_width;
	wnd_volume_width += wnd_volume_indent_x * 2;
	wnd_volume_height = wnd_volume_line_height;
	wnd_volume_height += wnd_volume_indent_y * 2;

	wnd_volume_pos_x = size_x;
	wnd_volume_pos_x -= wnd_volume_width;
	wnd_volume_pos_x /= 2;
	Assert((signed)wnd_volume_pos_x >= 0);
	Assert(wnd_volume_pos_x + wnd_volume_width <= (unsigned)size_x);
	wnd_volume_pos_y = size_y * 3 / 4;
}

void WndVolume_SetScale (uint scale)
{
	wnd_volume_requested_scale = scale;
	WndVolume_Scale ();
}

//void WndVolume_OffscreenBitmap_Free ();

// offscreen bitmap is necessary to exclude the flickers
//static bool WndVolume_OffscreenBitmap_Allocate ()
//static void WndVolume_OffscreenBitmap_Allocate (HDC hdc)
void WndVolume_OffscreenBitmap_Allocate ()
{
	HGDIOBJ hgdiobj;

#if 1
	HDC hdc;

	Assert(wnd_volume_hwnd);

	hdc = GetDC (wnd_volume_hwnd);
	if (! hdc)
		return;
#endif

// compatible to window
//	wnd_volume_hdc_test = CreateCompatibleDC (hdc);
//	if (! wnd_volume_hdc_test)
//		return;
// compatible to screen
//	wnd_volume_hdc_draw = CreateCompatibleDC (0);
	wnd_volume_hdc_draw = CreateCompatibleDC (hdc);
	if (! wnd_volume_hdc_draw)
//		goto free_allocated_items;
		return;
// WinAPI examples are using original HDC (the one, which is given to 'CreateCompatibleDC ()') in 'CreateCompatibleBitmap ()';
// but lets simplify.
// *'CreateCompatibleBitmap ()' returns 0 on 0 HDC
//	wnd_volume_bitmap_test = CreateCompatibleBitmap (wnd_volume_hdc_test, wnd_volume_width, wnd_volume_height);
//	if (! wnd_volume_bitmap_test)
//		goto free_allocated_items;
// "Note: When a memory device context is created, it initially has a 1-by-1 monochrome bitmap selected into it.
// If this memory device context is used in CreateCompatibleBitmap, the bitmap that is created is a monochrome bitmap.
// To create a color bitmap, use the hDC that was used to create the memory device context ..."
//	wnd_volume_bitmap_draw = CreateCompatibleBitmap (wnd_volume_hdc_draw, wnd_volume_width, wnd_volume_height);
	wnd_volume_bitmap_draw = CreateCompatibleBitmap (hdc, wnd_volume_width, wnd_volume_height);
	if (! wnd_volume_bitmap_draw)
		goto free_allocated_items;

//	hgdiobj = SelectObject (wnd_volume_hdc_test, wnd_volume_bitmap_test);
//	if (! hgdiobj)
//		goto free_allocated_items;
	hgdiobj = SelectObject (wnd_volume_hdc_draw, wnd_volume_bitmap_draw);
	if (! hgdiobj)
// *there is no any deselect function
// "An application should always replace a new object with the original, default object after it has finished drawing with the new object."
// but it never shows it in an examples
// no, it does show ("FireWnd.cpp"); 'hgdiobj' should be selected back, for 'wnd_volume_hdc_draw' deletion; or perhaps may delete it now, though it gives some asymmetry in the code
	{
//		goto deselect_bitmap_test;
		goto free_allocated_items;
	}

	wnd_volume_is_allocated = 1;

//	return 0;
	return;

free_allocated_items:
	WndVolume_OffscreenBitmap_Free ();
	return;
}

//static void WndVolume_OffscreenBitmap_Free ()
void WndVolume_OffscreenBitmap_Free ()
{
	BOOL B_result;

// or maybe HDC should be freed first; so it could free the bitmap, and not appeal at the dead handle of the bitmap (if it appeals)
	if (wnd_volume_bitmap_draw)
	{
		B_result = DeleteObject (wnd_volume_bitmap_draw);
		wnd_volume_bitmap_draw = 0;
	}
//	if (wnd_volume_bitmap_test)
//		B_result = DeleteObject (wnd_volume_bitmap_test);
	if (wnd_volume_hdc_draw)
	{
		B_result = DeleteDC (wnd_volume_hdc_draw);
		wnd_volume_hdc_draw = 0;
	}
//	if (wnd_volume_hdc_test)
//		B_result = DeleteDC (wnd_volume_hdc_test);

	wnd_volume_is_allocated = 0;
}

// draw background and grades
static void WndVolume_Bitmap_PaintBackground ()
{
	BOOL B_result;
	HBRUSH hbrush;
	RECT r;
	int i_result;
//	int i;
	int x0;
	int y0;
	int x1;
	int y1;
	HPEN hpen;

// don't assert it; allocation may fail, and ...
//	if (! wnd_volume_is_allocated)
//		return;

	Assert(wnd_volume_hdc_draw);
//	Assert(wnd_volume_bitmap_draw);
// it, and 'CreateSolidBrush ()' also will be some striped/rasterized, if the buffer bitmap will be monochrome
//	hbrush = (HBRUSH)GetStockObject (GRAY_BRUSH);
//	hbrush = (HBRUSH)GetStockObject (WHITE_BRUSH);
	hbrush = CreateSolidBrush (RGB(128, 128, 128));
//	hbrush = CreateSolidBrush (RGB(255, 128, 128));
// "When RECT is passed to the FillRect function, the rectangle is filled up to, but not including, the right column and bottom row of pixels."
#if 0
	B_result = GetClientRect (hwnd, &r);
#else
	r.left = 0;
	r.top = 0;
	r.right = wnd_volume_width;
	r.bottom = wnd_volume_height;
#endif
	i_result = FillRect (wnd_volume_hdc_draw, &r, hbrush);
	B_result = DeleteObject (hbrush);

// == draw grades ==
// *'PolyPolyline ()' also could be; but that isn't more simplier
#define WND_VOLUME_GRADES_NUM 0x10
// assertion test
//#define WND_VOLUME_GRADES_NUM 0x0f
#define WND_VOLUME_GRADE_VALUE (WND_VOLUME_LINE_BASIC_WIDTH / WND_VOLUME_GRADES_NUM)
//#define WND_VOLUME_GRADE_LENGTH (4 * wnd_volume_scale)
#define WND_VOLUME_GRADE_LENGTH (wnd_volume_indent_y * 3 / 4)
// static assert
	Assert(WND_VOLUME_GRADE_VALUE * WND_VOLUME_GRADES_NUM == WND_VOLUME_LINE_BASIC_WIDTH);
//	hpen = CreatePen (PS_SOLID, 1, RGB(0, 0, 0));
//	hpen = CreatePen (PS_SOLID, 5, RGB(255, 128, 0));
	hpen = CreatePen (PS_SOLID, wnd_volume_scale, RGB(0, 0, 0));
//	hpen = (HPEN)GetStockObject (BLACK_PEN);
	SelectObject (wnd_volume_hdc_draw, hpen);
// border (because on some (grey) surfaces, like a text edotor without an open document, our background is blended with its background)
	x0 = 0;
	y0 = 0;
	x1 = wnd_volume_width - 1;
	y1 = wnd_volume_height - 1;
	B_result = MoveToEx (wnd_volume_hdc_draw, x0, y0, 0);
	B_result = LineTo (wnd_volume_hdc_draw, x1, y0);
	B_result = LineTo (wnd_volume_hdc_draw, x1, y1);
	B_result = LineTo (wnd_volume_hdc_draw, x0, y1);
	B_result = LineTo (wnd_volume_hdc_draw, x0, y0);
// grades
	FORI0(WND_VOLUME_GRADES_NUM + 1)
	{
		x0 = wnd_volume_indent_x + i * WND_VOLUME_GRADE_VALUE * wnd_volume_scale;
		x1 = x0;
		y0 = wnd_volume_indent_y - 1;
		B_result = MoveToEx (wnd_volume_hdc_draw, x0, y0, 0);
		y1 = y0 - WND_VOLUME_GRADE_LENGTH;
		B_result = LineTo (wnd_volume_hdc_draw, x1, y1);
		y0 = wnd_volume_indent_y + wnd_volume_line_height;
		B_result = MoveToEx (wnd_volume_hdc_draw, x0, y0, 0);
		y1 = y0 + WND_VOLUME_GRADE_LENGTH;
		B_result = LineTo (wnd_volume_hdc_draw, x1, y1);
	}
	B_result = DeleteObject (hpen);
}

//// HDC allocations maybe shouldn't be here, but bitmaps - should
// and draw background actually
//void WndVolume_SetProperties ()
void WndVolume_SetPropertiesAndDrawBackground ()
{
	BOOL B_result;

//	if (wnd_volume_is_shown)
//		return;
//	Assert(! wnd_volume_is_shown);

#if 0
	HDC hdc;
	int i_result;

	Assert(! wnd_volume_is_allocated);
	Assert(wnd_volume_hwnd);
//	Assert(! wnd_volume_hdc_test);
	Assert(! wnd_volume_hdc_draw);
//	Assert(! wnd_volume_bitmap_test);
	Assert(! wnd_volume_bitmap_draw);

	hdc = GetDC (wnd_volume_hwnd);
	if (! hdc)
		return;

	WndVolume_OffscreenBitmap_Allocate (hdc);
	i_result = ReleaseDC (wnd_volume_hwnd, hdc);
#else
//	Assert(wnd_volume_is_allocated);
#endif

	if (! wnd_volume_is_allocated)
// todo: warn
		return;

	Assert(wnd_volume_hdc_draw);
	Assert(wnd_volume_bitmap_draw);

//	WndVolume_DrawBitmapTest ();
//	WndVolume_DrawBitmapDraw ();
//	WndVolume_DrawBitmapDraw (hdc);
// pre-draw the offscreen bitmap, so that will remain only to draw the percentage stripe upon it
	WndVolume_Bitmap_PaintBackground ();

	DWORD style;
//	bool r;
//	ulong transparency;
	LONG l;

	style = 0;
//	transparency = 0x80000000;
//	style = GetWindowLong (mh_wnd, GWL_EXSTYLE);
// pass mouse events through (hmmm, works only when WS_EX_LAYERED)
	style |= WS_EX_TRANSPARENT;
	style |= WS_EX_TOOLWINDOW;
// make the window transparent/translucent
// *if just set this flag, and not request 'SetLayeredWindowAttributes ()', the window is invisible
	style |= WS_EX_LAYERED;
	l = SetWindowLong (wnd_volume_hwnd, GWL_EXSTYLE, style);

	if (pfnSetLayeredWindowAttributes)
	{
// Set 'WS_EX_LAYERED' on this window
//		SetWindowLong (mh_wnd, GWL_EXSTYLE, GetWindowLong (mh_wnd, GWL_EXSTYLE) | WS_EX_LAYERED);
// set window alpha
// "Please remember that once SetLayeredWindowAttributes has been called on a layered window, subsequent UpdateLayeredWindow calls will fail until the layering style bit is cleared and set again."
//		B_result = pfnSetLayeredWindowAttributes (wnd_volume_hwnd, 0, (byte)(transparency >> 24), LWA_ALPHA);
		B_result = pfnSetLayeredWindowAttributes (wnd_volume_hwnd, 0, wnd_volume_opacity, LWA_ALPHA);
// test
// with 0 opacity, it doesn't catch the mouse cursor anymore; with 1 it does;
// and on 0 opacity, 'WndProc ()' stops to receive any messages about mouse cursor above the window
//		B_result = pfnSetLayeredWindowAttributes (wnd_volume_hwnd, 0, 0, LWA_ALPHA);
//		B_result = pfnSetLayeredWindowAttributes (wnd_volume_hwnd, 0, 1, LWA_ALPHA);
	}

// '-1' not centers
//	B_result = MoveWindow (wnd_volume_hwnd, -1, -1, wnd_volume_width, wnd_volume_height, 0);
//	B_result = MoveWindow (wnd_volume_hwnd, 0, 0, wnd_volume_width, wnd_volume_height, 0);
// position the window on where the drawing will be, to get WM_PAINT messages about that screen region
//	B_result = SetWindowPos (wnd_volume_hwnd, HWND_TOPMOST, wnd_volume_pos_x, wnd_volume_pos_y, wnd_volume_width, wnd_volume_height, SWP_FRAMECHANGED);
//	B_result = SetWindowPos (wnd_volume_hwnd, HWND_TOPMOST, 0, 0, wnd_volume_width, wnd_volume_height, SWP_FRAMECHANGED | SWP_NOACTIVATE);
	B_result = SetWindowPos (wnd_volume_hwnd, HWND_TOPMOST, wnd_volume_pos_x, wnd_volume_pos_y, wnd_volume_width, wnd_volume_height, SWP_FRAMECHANGED | SWP_NOACTIVATE);

	return;

//deselect_bitmap_test:
//	;
//destroy_bitmap_test:
//	B_result = DeleteObject (wnd_volume_bitmap_test);
//free_allocated_items:
//	WndVolume_OffscreenBitmap_Free ();
}

void WndVolume_Show ()
{
	BOOL B_result;

//	WndVolume_SetProperties ();
	WndVolume_SetPropertiesAndDrawBackground ();
	Assert(wnd_volume_hwnd);
// 'SW_SHOWNA' or 'SW_SHOWNOACTIVATE' should be; they aren't activating the window
//	B_result = ShowWindow (wnd_volume_hwnd, SW_SHOW);
// both are a bit bugged above an SDL's window
	B_result = ShowWindow (wnd_volume_hwnd, SW_SHOWNA);
//	B_result = ShowWindow (wnd_volume_hwnd, SW_SHOWNOACTIVATE);
	B_result = UpdateWindow (wnd_volume_hwnd);

	return;

//deselect_bitmap_test:
//	;
//destroy_bitmap_test:
//	B_result = DeleteObject (wnd_volume_bitmap_test);
//free_allocated_items:
//	WndVolume_OffscreenBitmap_Free ();
}

void WndVolume_Hide ()
{
	BOOL B_result;

//	Assert(wnd_volume_is_allocated);
	if (! wnd_volume_is_shown)
		return;

	B_result = ShowWindow (wnd_volume_hwnd, SW_HIDE);
	B_result = UpdateWindow (wnd_volume_hwnd);

//	B_result = DeleteObject (wnd_volume_bitmap_draw);
//	B_result = DeleteObject (wnd_volume_bitmap_test);
//	WndVolume_OffscreenBitmap_Free ();
}

void WndVolume_SetValue (ulong value)
{
	BOOL B_result;

	wnd_volume_value = value;
// provoke WM_PAINT
	if (wnd_volume_hwnd)
		B_result = InvalidateRect (wnd_volume_hwnd, 0, 0);
}

//void WndVolume_Undisplay ();
void WndVolume_Undisplay (bool hide);
VOID CALLBACK WndVolume_TimerProc (HWND hwnd, UINT msg, UINT event, DWORD time);

// it is with a timer; requestor calls this, and doesn't calling later a function to remove the window
void WndVolume_Display ()
{
	if (wnd_volume_timer)
//		WndVolume_Undisplay ();
		WndVolume_Undisplay (0);

	if (! wnd_volume_show)
		return;
// (according to MSDN) it still will go through the 'DispatchMessage ()', 'DefWindowProc ()', 'case WM_TIMER:'
	wnd_volume_timer = SetTimer (0, 0, wnd_volume_timer_elapse_ms, WndVolume_TimerProc);
	if (! wnd_volume_timer)
		return;
	WndVolume_Show ();
}

//void WndVolume_Undisplay ()
// 'hide = 0' is necessary to just request a cleanup :  timer remove;
// could be done by just doing a separate function, but I want it this way atm
void WndVolume_Undisplay (bool hide)
{
	BOOL B_result;

	if (hide)
		WndVolume_Hide ();
	B_result = KillTimer (0, wnd_volume_timer);
	wnd_volume_timer = 0;
}

VOID CALLBACK WndVolume_TimerProc (HWND hwnd, UINT msg, UINT event, DWORD time)
{
//	WndVolume_Undisplay ();
	WndVolume_Undisplay (1);
}

// paint the line with its background; write percents in text above the line (the stripe)
// *to draw a text, which have a different colours at two sides of the stripe, other applications aren't using some new api, but just are drawing in a specific order
static void WndVolume_Paint (HDC hdc)
{
	BOOL B_result;
	HBRUSH hbrush_bkgr;
	HBRUSH hbrush_ink;
	RECT r;
	int i_result;
//	HDC hdc;
	ulong length;

	Assert(wnd_volume_is_allocated);
	Assert(wnd_volume_hdc_draw);
	Assert(wnd_volume_bitmap_draw);

// +++ stripe +++
//	hbrush = (HBRUSH)GetStockObject (GRAY_BRUSH);
//	hbrush = (HBRUSH)GetStockObject (BLACK_BRUSH);
// test
//	hbrush = CreateSolidBrush (RGB(0, 128, 128));
	hbrush_bkgr = CreateSolidBrush (RGB(0, 0, 0));
	if (wnd_volume_discoloured)
		hbrush_ink = CreateSolidBrush (RGB(64, 64, 64));
	else
		hbrush_ink = CreateSolidBrush (RGB(32, 32, 255));

//	i_result = SetBkMode (wnd_volume_hdc_draw, TRANSPARENT);

	length = wnd_volume_value * wnd_volume_line_width;
//	length >>= 16;
	length /= 0xffff;

#if 0
	r.left = 0;
	r.top = 0;
	r.right = wnd_volume_width;
	r.bottom = wnd_volume_height;
#endif

	r.left = wnd_volume_indent_x;
	r.top = wnd_volume_indent_y;
	r.right = wnd_volume_indent_x + wnd_volume_line_width;
	r.bottom = wnd_volume_indent_y + wnd_volume_line_height;

	i_result = FillRect (wnd_volume_hdc_draw, &r, hbrush_bkgr);

	r.right = wnd_volume_indent_x + length;

	i_result = FillRect (wnd_volume_hdc_draw, &r, hbrush_ink);

	if (hbrush_bkgr)
		B_result = DeleteObject (hbrush_bkgr);
	if (hbrush_ink)
		B_result = DeleteObject (hbrush_ink);
// --- stripe ---

// +++ percent text +++
#if 1
	char text[32];
	HFONT hfont;
	uint font_height;

//	font_height = 13;
//	font_height = wnd_volume_line_height * 6 / 11;
	font_height = wnd_volume_line_height - 1;
	hfont = CreateFont
		(
		font_height, 0, 0, 0, 400,
// 'DEFAULT_QUALITY' and 'PROOF_QUALITY' are antialiased
// ha, antialiased big fonts are looking better than nonantialiased
		0, 0, 0, ANSI_CHARSET, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, DEFAULT_QUALITY, DEFAULT_PITCH,
//		0, 0, 0, ANSI_CHARSET, OUT_CHARACTER_PRECIS, CLIP_CHARACTER_PRECIS, NONANTIALIASED_QUALITY, DEFAULT_PITCH,
//		"Verdana"
// Arial have bigger horizontal density
//		"Arial"
// aligned console font
		"Lucida Console"
		);
	if (hfont)
		SelectObject (wnd_volume_hdc_draw, hfont);
//	hbrush_ink = CreateSolidBrush (RGB(192, 192, 32));
//	if (hbrush_ink)
//		SelectObject (wnd_volume_hdc_draw, hbrush_ink);
	if (wnd_volume_discoloured)
		SetTextColor (wnd_volume_hdc_draw, RGB(192, 192, 192));
	else
		SetTextColor (wnd_volume_hdc_draw, RGB(192, 192, 32));

	i_result = SetBkMode (wnd_volume_hdc_draw, TRANSPARENT);
// and about this I am not sure :  maybe left it just yellow
// does not relate at 'TextOut ()'
//	SetROP2 (wnd_volume_hdc_draw, R2_BLACK);
//	SetROP2 (wnd_volume_hdc_draw, R2_NOT);
// hehe, no option; it is drawn with just 'SetTextColor ()' colour, and nothing more can do about it (and no big need)
// in other applications, inverted fonts perhaps are done by drawing the text first, and then drawing the stripe upon it with xor

// is possible to use 'GetTextExtentPoint32 ()' to get string size, but lets try OS alignment
	SetTextAlign (wnd_volume_hdc_draw, TA_CENTER | TA_TOP | TA_NOUPDATECP);

//	sprintf (text, "%02u", (wnd_volume_value * 100) >> 16);
	sprintf (text, "%02u%%", wnd_volume_value * 100 / 0xffff);
//	B_result = TextOut (wnd_volume_hdc_draw, wnd_volume_indent_x, wnd_volume_indent_y + wnd_volume_scale + 1, text, strlen(text));
	B_result = TextOut (wnd_volume_hdc_draw, wnd_volume_indent_x + wnd_volume_line_width / 2, wnd_volume_indent_y + wnd_volume_scale + 1, text, strlen(text));

	if (hfont)
		B_result = DeleteObject (hfont);
//	if (hbrush_ink)
//		B_result = DeleteObject (hbrush_ink);
#endif
// --- percent text ---

// 0 result, if destination HDC is 0
	B_result = BitBlt (hdc, 0, 0, wnd_volume_width, wnd_volume_height, wnd_volume_hdc_draw, 0, 0, SRCCOPY);
// test
//	i_result = FillRect (hdc, &r, hbrush);
}

// volume 'WndProc ()'
LRESULT CALLBACK WndVolume_WndProc (HWND hwnd, UINT msg, WPARAM wparam, LPARAM lparam)
{
	BOOL B_result;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (msg)
	{
	case WM_CREATE:
		break;

	case WM_DESTROY:
		break;

// this message is cyclically rerequested again and again, if wasn't served
// (not by return value, but it somehow knows, that 'BeginPaint ()'-'EndPaint()' pair has been requested).
// is requested only once; and if later there is some appearance of some window below this one, then no request of this is appearing again
	case WM_PAINT:
//		if (! wnd_volume_is_allocated)
//			return 0;
		hdc = BeginPaint (hwnd, &ps);
// test
#if 0
		RECT r;
		B_result = GetClientRect (hwnd, &r);
		FillRect (hdc, &r, (HBRUSH)GetStockObject (GRAY_BRUSH));
		TextOut (hdc, 0, 0, "hello world :)", 14);
#endif
//		B_result = BitBlt (hdc, 0, 0, wnd_volume_width, wnd_volume_height, wnd_volume_hdc_test, 0, 0, SRCCOPY);
#if 1
		if (wnd_volume_is_allocated)
			WndVolume_Paint (ps.hdc);
#endif
// test
#if 0
		int i_result;
		RECT r;
		HBRUSH hbrush;
		B_result = GetClientRect (hwnd, &r);
		hbrush = CreateSolidBrush (RGB(255, 0, 255));
		i_result = FillRect (hdc, &r, hbrush);
		B_result = DeleteObject (hbrush);
#endif
		B_result = EndPaint (hwnd, &ps);
//		break;
		return 0;

	case WM_CLOSE:
// shouldn't actually go here
		return 0;
//		break;

// for flicker preventing - just return 1, saying that we've handled it
	case WM_ERASEBKGND:
#if 0
		hdc = (HDC)wparam; 
		GetClientRect (hwnd, &rc); 
		SetMapMode(hdc, MM_ANISOTROPIC); 
		SetWindowExtEx(hdc, 100, 100, NULL); 
		SetViewportExtEx(hdc, rc.right, rc.bottom, NULL); 
		FillRect(hdc, &rc, hbrWhite); 
		
		for (i = 0; i < 13; i++)
		{
			x = (i * 40) % 100; 
			y = ((i * 40) / 100) * 20; 
			SetRect(&rc, x, y, x + 20, y + 20); 
			FillRect(hdc, &rc, hbrGray); 
		} 
#endif
		return 1;

	case WM_SHOWWINDOW:
		wnd_volume_is_shown = !! wparam;
		break;

// unnecessary stuff, if allocations will be done each time when this window is shown
#if 1
	case WM_DISPLAYCHANGE:
// if we are visible
// hmmm, why not ?  it is an offscreen bitmap needs to be reallocated
//		if (1)
//			break;
// drop allocated stuff
		if (wnd_volume_is_allocated)
			WndVolume_OffscreenBitmap_Free ();
// recalculate size
//		WndVolume_Scale (wnd_volume_requested_scale);
		WndVolume_Scale ();
// and allocate anew
		WndVolume_OffscreenBitmap_Allocate ();
//		WndVolume_Bitmap_PaintBackground ();
		WndVolume_SetPropertiesAndDrawBackground ();
		break;
#endif

	default:
		break;
//		goto def_window_proc;
	}

//def_window_proc:
	return DefWindowProc (hwnd, msg, wparam, lparam);
}

